﻿#Persistent
#NoTrayIcon
#SingleInstance, Force
#Include <JSON>
DetectHiddenWindows On
SetTitleMatchMode 2
If (A_Args[1]="")
	ExitApp
CopyOfData:="", ReceivePID:=0
; OnMessage(0x4a, "Receive_WM_COPYDATA")
OnMessage(10000, "ReceiveMsg")
; SetTimer, BDCloudInput, 10
Return

ReceiveMsg(wParam, lParam){
	global ReceivePID, Texthwnd
	ReceivePID:=wParam, Texthwnd:=lParam
	SetTimer, BDCloudInput, -5
}
; Receive_WM_COPYDATA(wParam, lParam){
;     global CopyOfData, ReceivePID
; 	StringAddress := NumGet(lParam + 2*A_PtrSize)  ; 获取 CopyDataStruct 的 lpData 成员.
; 	CopyOfData := StrGet(StringAddress)  ; 从结构中复制字符串.
;     ReceivePID := wParam
; 	SetTimer, BDCloudInput, -5
;     ; OutputDebug, % "Receive_COPYDATA|" CopyOfData
; 	Return true  ; 返回 1 (true) 是回复此消息的传统方式.
; }

Send_WM_COPYDATA(ByRef StringToSend, ByRef TargetScriptTitle)  ; 在这种情况中使用 ByRef 能节约一些内存.
; 此函数发送指定的字符串到指定的窗口然后返回收到的回复.
; 如果目标窗口处理了消息则回复为 1, 而消息被忽略了则为 0.
{
    VarSetCapacity(CopyDataStruct, 3*A_PtrSize, 0)  ; 分配结构的内存区域.
    ; 首先设置结构的 cbData 成员为字符串的大小, 包括它的零终止符:
    SizeInBytes := (StrLen(StringToSend) + 1) * (A_IsUnicode ? 2 : 1)
    NumPut(SizeInBytes, CopyDataStruct, A_PtrSize)  ; 操作系统要求这个需要完成.
    NumPut(&StringToSend, CopyDataStruct, 2*A_PtrSize)  ; 设置 lpData 为到字符串自身的指针.
    ; 必须使用发送 SendMessage 而不是投递 PostMessage.
    SendMessage, 0x4a, % DllCall("GetCurrentProcessId"), &CopyDataStruct,, %TargetScriptTitle%  ; 0x4a 为 WM_COPYDAT
    return ErrorLevel  ; 返回 SendMessage 的回复给我们的调用者.
}

BDCloudInput(input){
	static hObject
	If (!hObject){
		hObject:=ComObjCreate("WinHttp.WinHttpRequest.5.1")
		hObject.SetTimeouts(100, 100, 100, 100)
	}
	hObject.Open("GET", "http://olime.baidu.com/py?input=" StrReplace(input,"'") "&inputtype=py&bg=0&ed=20&result=hanzi&resultcoding=utf-8&ch_en=0&clientinfo=web&version=1", False)  
	Try {
		hObject.Send()
		obj:=JSON.Load(hObject.ResponseText).result.1.1
	}
	If obj[1]
		Return obj[3,"pinyin"] "`n" obj[1] "`n" input
	Return
}
BDCloudInput:
	If (Msg:=GetText(Texthwnd)){
		result:=BDCloudInput(Msg)
		If (result="")&&(Msg:=GetText(Texthwnd))
			result:=BDCloudInput(Msg)
		If (result!="")&&(Msg=GetText(Texthwnd))
			Send_WM_COPYDATA("<<CloudResult>>" result, "ahk_class AutoHotkey ahk_pid" ReceivePID)
	}
Return

GetText(Hwnd){
	ControlGetText, Msg, , ahk_id%Hwnd%
	Return Msg
}