﻿;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;~ 作         者:  河许人 && 天黑请闭眼
;~ 脚本说明： 影子输入法，承影（texter热字符，）_hello_srf柚子输入法，输入要做的就是
;~ 环境 版本:   Autohotkey v1.1.32.00 Win10Pro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 部分自定义设置（热键修改等）可以写入主目录\Lib\usercustoms.ahk文件中
#NoEnv
#MaxMem 128
#MaxThreads, 5
#KeyHistory, 0
#SingleInstance, Force
#MaxThreadsPerHotkey 2

OnExit, Exit
ListLines, Off
SetBatchLines, -1
SetKeyDelay, 0, 0
Process, Priority,, High
CoordMode, Caret, Screen
CoordMode, Mouse, Screen
CoordMode, ToolTip, Screen
SetWorkingDir %A_ScriptDir%
OnClipboardChange("ClipChanged")
OnMessage(0x201, "WM_LBUTTONDOWN")
OnMessage(0x4a, "Receive_WM_COPYDATA")
func_key:="/"
srf_symbol:={"``":["``","·"], "~":["~","~"], "!":["!","！"], "@":["@","@"], "#":["#","#"], "$":["$","￥"], "%":["%","%"], "^":["^","……"], "&":["&","&"], "*":["*","*"], "(":["(","（）{Left}"], ")":[")","）"]
, "_":["_","——"], "-":["-","-"], "+":["+","+"], "=":["=","="], "[":["[","【】{Left}"], "]":["]","】"], "{":["{","{}{Left}"], "}":["}","}"], "\":["\","、"], "|":["|","|"], ";":[";","；"], ":":[":","："]
, "'":["'","‘’{Left}"], """":["""","“”{Left}"], "<":["<","《》{Left}"],">":[">","》"],",":[",","，"],".":[".","。"], "/":["/","/"], "?":["?","？"]}
Gosub srf_init
#Include *i Lib\usercustoms.ahk
Return

Registrationhotkey:		; 注册快捷键
	Try {								; 注册切换热键
		Hotkey, %Switch%, srfSwitch, On
		If !InStr(Switch,"&")&&(Switch~="i)(L|R)?(Win|Alt|Shift|Control|Ctrl|CapsLock)")
			Try Hotkey, % Trim(Switch,"+!#^") " & F24", AndLButton, On
	} Catch
		MsgBox, 16, 错误, 注册切换热键失败，请手动在[选项>控制]中设置其他热键！！！, 3

	symbolmode_funobj:=Func("symbolmode").Bind()
	cncharmode_funobj:=Func("cncharmode").Bind()
	Hotkey If, % cncharmode_funobj
	Loop 26 {
		Hotkey, % "+" Chr(96+A_Index), cnInputchar, On
		Hotkey, % Chr(96+A_Index), cnInputchar, On
	}
	Hotkey, If
	Hotkey If, % symbolmode_funobj
	For key, value In srf_symbol
		Hotkey, %key%, Sendsymbol, on
	Loop 26 {
		Hotkey, % "+" Chr(96+A_Index), Inputchar, On
		Hotkey, % Chr(96+A_Index), Inputchar, On
	}
	Hotkey, If

	Hotkey, If, srf_inputing
	Loop 10 {
		Hotkey, % A_Index-1, srf_select_ci, On
		Hotkey, % "Numpad" A_Index-1, srf_select_ci, On
	}
	Hotkey, PgUp, lessWait, On
	Hotkey, PgDn, MoreWait, On
	Hotkey, If
Return

symbolmode(){
	global srf_mode, EnChar
	Return EnChar||(srf_mode&&!GetKeyState("CapsLock", "T"))
}
cncharmode(){
	global srf_mode
	Return (srf_mode&&!GetKeyState("CapsLock", "T"))
}

!^F12::
srfsuspend:
	Suspend
	Gosub srf_value_off
	If (A_IsSuspended){
		Gui, 2:Hide
		Menu, Tray, Rename, 8&, 恢复
		Menu, Tray, Icon, Lib\yz.icl, 2, 1
	} Else {
		srf_mode:=1
		Gui, 2:Show, NA
		Menu, Tray, Rename, 8&, 禁用
		Menu, Tray, Icon, Lib\yz.icl, 1, 1
	}
Return
srfreload:
	Reload
	ExitApp

srfSwitch:
	Suspend, Permit
	HoldKey:=RegExReplace(A_ThisHotkey,"i)^([<>$\^!+#]+)?([a-z ]+&[ ]+)?([a-z\d]+)$","$3")
	If (A_IsSuspended){
		If !(HoldKey~="i)^(L|R)?(Shift|Alt|Win|Ctrl|Control)$")
			KeyWait, % HoldKey
	} Else {
		If !(HoldKey~="i)^(L|R)?(Shift|Alt|Win|Ctrl|Control)$")
			KeyWait, % HoldKey
		If (srf_mode:=!srf_mode){
			Gui, 2:Show, NA
		} Else {
			Gui, 2:Hide
			If (Shiftfg=2)&&(A_ThisHotkey~="Shift$")&&srf_inputing
				SendInput(srf_all_Input, SendDelaymode)
			Gosub srf_value_off
		}
	}
	; 双击禁用
	If Double&&A_ThisHotkey&&(A_PriorHotkey=A_ThisHotkey)&&(A_TimeSincePriorHotkey<350){
		Gosub srfsuspend
	}
Return

AndLButton:
	Suspend, Permit
	Send {Blind}{F24}
Return

#If srf_inputing&&!InStr(srf_all_Input,func_key)
	^1::
	^2::
	^3::
	^4::
	^5::
	^6::
	^7::
	^8::
	^9::
	^0::srf_SetFirst(SubStr(A_ThisHotkey,0))

	^!1::
	^!2::
	^!3::
	^!4::
	^!5::
	^!6::
	^!7::
	^!8::
	^!9::
	^!0::srf_delete(SubStr(A_ThisHotkey,0))
#If

; 空格、0-9 定义
#If srf_inputing
	Space::
		If !InStr(srf_all_Input,func_key)
			srf_select(1, IsPinyin)
		Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$")
			srf_HotStringSelect(Function_for_select,1)
		Else If InStr(srf_all_Input,func_key)
			srf_RunSelect(Function_for_select)
	Return
	srf_select_ci:
		ThisHotkey:=StrReplace(A_ThisHotkey,"Numpad")
		; If (jichu_for_select_Array[1,0]="pinyin")&&((ThisHotkey?ThisHotkey:10)<StrLen(jichu_for_select_Array[1,2])){
		; 	KeyWait, %A_ThisHotkey%, T0.3
		; 	If (ErrorLevel){
		; 		srf_select(ThisHotkey, IsPinyin, A_ThisHotkey)
		; 		Return
		; 	}
		; }
		srf_select(ThisHotkey, IsPinyin)
	Return

	fencifu:
		If InStr("'\",SubStr(srf_all_Input, 0))
			Return
		If (A_ThisHotkey="\")&&!InStr(srf_all_Input, func_key){
			If !InStr(srf_all_Input_raw_for_trim,"'")
				Return
			tvar:=save_field_array[1,0]
			Loop {
				tvar:=RegExReplace(Trim(tvar,"'"),"(^|')[a-z]+$")
			} Until (history_field_array[tvar,"",1]||(tvar=""))
			If (tvar){
				RegExMatch(srf_all_Input_raw_for_trim "'", "([a-z]+'){" StrSplit(tvar,"'").Length() "}", tvar)
				srf_all_Input:=RegExReplace(StrReplace(srf_all_Input,"\"), "(" StrReplace(tvar,"'","'?") ")","$1\")
			} Else
				srf_all_Input:=StrReplace(srf_all_Input,"\"), save_field_array.RemoveAt(1)
			pinyinmethod(srf_all_Input,Inputscheme)
			Gosub houchuli
			Gosub srf_tooltip_fanye
		} Else {
			srf_all_Input .= A_ThisHotkey, waitnum:=0
			Gosub srf_tooltip_fanye
		}
	Return

	;srf_all_input模式 backspace键、esc键、enter键、Lshift键 定义
	BackSpace::
		srf_all_Input:=SubStr(srf_all_Input, 1, -1), waitnum:=0
		If (srf_all_Input = "")
			Gosub srf_value_off
		Else If (srf_all_Input = func_key){
			ToolTipText:=func_key, srf_for_select:="(" func_key ") " srf_symbol[func_key,2-EnSymbol]
			Gosub showhouxuankuang
		} Else
			Gosub srf_tooltip
	Return

	Shift::
		If (Shiftfg=2)
			SendInput(srf_all_Input, SendDelaymode)
		Gosub srf_value_off
		If (Switch~="Shift"){
			Gui, 2:Hide
			srf_mode:=0
			; If (IME_Return_0E1C() = 1)
			; 	SwitchToEngIME()
		}
	Return

	Enter::
	NumpadEnter::
		If (Enterfg=2)
			SendInput(srf_all_Input, SendDelaymode)
		Gosub srf_value_off
	Return
#If

; srf_mode模式 a-z键、esc键、中文符号 定义
#If ((Escfg>1)&&srf_mode)||((Escfg!=2)&&srf_inputing)
Esc::
	If srf_inputing
		Gosub srf_value_off
	Else {
		srf_mode:=0
		; If (IME_Return_0E1C() = 1)
		; 	SwitchToEngIME()
		Gui, 2:Hide
	}
	If (Escfg=3) {
		srf_mode:=0
		; If (IME_Return_0E1C() = 1)
		; 	SwitchToEngIME()
		Gui, 2:Hide
	}
	; Gosub srf_hotkey_switch
Return
#If

#If srf_mode&&(InStr(srf_all_Input,func_key))
	1::
	2::
	3::
	4::
	5::
	6::
	7::
	8::
	9::
	0::
	.::
	Numpad1::
	Numpad2::
	Numpad3::
	Numpad4::
	Numpad5::
	Numpad6::
	Numpad7::
	Numpad8::
	Numpad9::
	Numpad0::
	NumpadDot::
	ThisHotkey:=StrReplace(A_ThisHotkey,"Numpad")
	ThisHotkey:=(ThisHotkey="Dot"?".":ThisHotkey)
	If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$"){
		srf_HotStringSelect(Function_for_select, (ThisHotkey="."?4:ThisHotkey))
	} Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_function")||!(modeMatch.Value[1]=""||srf_Default_Func[srf_func_table[modeMatch.Value[1], "Name"],2]~="\d"){
		srf_RunSelect(Function_for_select, (ThisHotkey="."?4:ThisHotkey))
	} Else {
		If (ThisHotkey=".")&&(InStr(srf_all_Input, ".")||srf_all_Input=func_key)
			Return
		srf_all_Input .= ThisHotkey
		Gosub srf_tooltip
	}
Return
#If

#If srf_mode
	^=::srf_create("dy|" (srf_all_Input?srf_all_Input "=":""))
#If

#If srf_mode&&!srf_inputing
	~1::
	~2::
	~3::
	~4::
	~5::
	~6::
	~7::
	~8::
	~9::
	~0::
	numberfg:=1
	Return
#If

Inputchar:
	If (srf_mode&&(shurulei="xingma")&&pinyinhunsu&&!srf_inputing){
		srf_all_Input:="Z", waitnum:=numberfg:=0, srf_for_select:=""
		Goto srf_tooltip
	}
	SendInput(GetKeyState("CapsLock", "T")^GetKeyState("Shift", "P")?Format("{:U}", LTrim(A_ThisHotkey,"+")):LTrim(A_ThisHotkey,"+"))
Return

#If srf_mode&&!GetKeyState("CapsLock")
; 设置热键
; a-z定义
; 设置热键
	cninputchar:
	Critical, On
	RunTime:=[["Begin",A_TickCount]], srf_inputing:=1
	srf_all_Input .= GetKeyState("Shift", "P")?Format("{:U}", LTrim(A_ThisHotkey,"+")):A_ThisHotkey, waitnum:=numberfg:=0, srf_for_select:=""
	; If !InStr(srf_all_Input, func_key)
	; 	srf_all_Input:=RegExReplace(srf_all_Input,"([aeio])gn","$1ng")
	Gosub srf_tooltip
	; SetTimer srf_tooltip, -10
Return

Sendsymbol:
	If srf_inputing {
		RegExMatch(srf_all_Input,"O)^" func_key "?(.+)" func_key, Match)
		If ((ThisHotkey:=A_ThisHotkey)=","){
			If hotstring_for_select[1, 1]&&!InStr(srf_all_Input,func_key)
				srf_HotStringSelect(hotstring_for_select)
			Else {
				If (!InStr(srf_all_Input,func_key))
					srf_select(3, IsPinyin)
				Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$")
					srf_HotStringSelect(Function_for_select, 3)
				Else
					srf_RunSelect(Function_for_select, 3)
				Return
			}
		} Else If (ThisHotkey="."){
			If Function_for_select[1, 1]&&!InStr(srf_all_Input,func_key)
				srf_RunSelect(Function_for_select)
			Else {
				If (!InStr(srf_all_Input,func_key))
					srf_select(4, IsPinyin)
				Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$")
					srf_HotStringSelect(Function_for_select, 4)
				Else
					srf_RunSelect(Function_for_select, 4)
				Return
			}
		} Else If (ThisHotkey="'"){
			If ((!InStr(srf_all_Input,func_key)&&Inputscheme~="pinyin|sp$")||(IsPinyin))
				Gosub fencifu
			Else {
				If (!InStr(srf_all_Input,func_key))
					srf_select(3, IsPinyin)
				Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$")
					srf_HotStringSelect(Function_for_select, 3)
				Else
					srf_RunSelect(Function_for_select, 3)
				Return
			}
		} Else If (ThisHotkey="\"){
			If (Inputscheme~="pinyin|sp$")
				Gosub fencifu
		} Else If (ThisHotkey=";"){
			If (Inputscheme~="(wr|sg)sp"){
				srf_all_Input:=srf_all_Input ";", waitnum:=numberfg:=0
				Gosub srf_tooltip
			} Else {
				If (!InStr(srf_all_Input,func_key))
					srf_select(2, IsPinyin)
				Else If (srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring")||(srf_all_Input~="^" func_key "[a-z]+$")
					srf_HotStringSelect(Function_for_select, 2)
				Else
					srf_RunSelect(Function_for_select, 2)
				Return
			}
		} Else If (ThisHotkey=func_key){
			If (srf_all_Input=func_key){
				Gosub srf_value_off
				SendInput(srf_symbol[func_key,2-EnSymbol])
			} Else If (SubStr(srf_all_Input,0)!=func_key)&&!(srf_func_table[modeMatch.Value[1], "Name"]="get_hotstring"){
				srf_all_Input .= func_key
				Gosub srf_tooltip
			}
		} Else If InStr(fanyefg, ThisHotkey){
			If (ThisHotkey~="-|\[")
				Gosub lessWait
			Else
				Gosub MoreWait
		}
	} Else {
		If (A_ThisHotkey=".")&&(numberfg){
			Send {.}
		} Else If (A_ThisHotkey=func_key){
			If (srf_mode){
				srf_all_Input:=func_key, ToolTipText:=A_ThisHotkey, srf_for_select:="(" A_ThisHotkey ") " srf_symbol[A_ThisHotkey,2-EnSymbol], srf_inputing:=1
				Gosub showhouxuankuang
			} Else
				SendInput(srf_symbol[A_ThisHotkey,1])
		} Else If srf_mode&&(A_ThisHotkey=";")&&!(Inputscheme~="sp$|pinyin"){
			srf_all_Input:=";", waitnum:=numberfg:=0
			Gosub srf_tooltip
		} Else {
			tvar:=srf_symbol[A_ThisHotkey,(srf_mode&&!EnSymbol&&!GetKeyState("CapsLock", "T"))+1]
			SendInput(StrReplace(tvar,"{Left}"))
			If InStr(tvar,"{Left}")
				SendInput {Left}
		}
	}
	numberfg:=0
Return
#If

#If ClipSaved
$^v::
recoverclip:
	Clipboard:=ClipSaved, ClipSaved:=""
	SendInput, ^v
Return

ClipChanged(Type) {
    global ClipSaved
	ClipSaved:=""
}
#If

ToolTipOff:
	ToolTip
Return

; 窗口拖动
WM_LBUTTONDOWN(){
	ToolTip
	If (A_Gui=2)||(A_Gui="TSF")||(A_Gui="")
	; If (A_Gui=2)
		PostMessage, 0xA1, 2
}

EXIT:
	DB:="", EmptyMem(), YzIni.Save(), hideorshowwindows("a")
	For Key, Value in srf_Plugins
		Process, Close, % Value[1]
	ExitApp

; 来源: http://www.autohotkey.com/forum/topic32876.html
EmptyMem(PID="AHK Rocks"){
	pid:=(pid="AHK Rocks") ? DllCall("GetCurrentProcessId") : pid
	h:=DllCall("OpenProcess", "UInt", 0x001F0FFF, "Int", 0, "Int", pid)
	DllCall("SetProcessWorkingSetSize", "UInt", h, "Int", -1, "Int", -1)
	DllCall("CloseHandle", "Int", h)
}

; 切换键盘模式
SwitchToEngIME(){
	; 下方代码可只保留一个
	SwitchIME(0x04090804)
}
SwitchIME(dwLayout){
	ControlGetFocus, ctl, A
	SendMessage, 0x50, 0, %dwLayout%, %ctl%, A
}

IME_Return_0E1C(WinTitle="A"){			;借鉴了某日本人脚本中的获取输入法状态的内容,减少了不必要的切换,切换更流畅了
	;~ ifEqual WinTitle,,  SetEnv,WinTitle,A
	WinGet, hWnd, ID, %WinTitle%
	DefaultIMEWnd:=DllCall("imm32\ImmGetDefaultIMEWnd", Uint, hWnd, Uint)

	;Message : WM_IME_CONTROL  wParam:IMC_GETOPENSTATUS
	DetectSave:=A_DetectHiddenWindows
	DetectHiddenWindows, ON
	SendMessage 0x283, 0x005, 0, ,ahk_id %DefaultIMEWnd%
	DetectHiddenWindows, %DetectSave%
	Return ErrorLevel
}

; Include
#Include %A_ScriptDir%
#Include Lib\Gdip.ahk		; Gdip类库
#Include Lib\EasyIni.ahk	; ini类库
#Include Lib\Class_SQLiteDB.ahk	; SQLite类库
#Include Lib\Class_Everything.ahk	; Everything类库
#Include Lib\ToolTip.ahk	; ToolTip样式
#Include Lib\GdipText.ahk	; Gdip样式候选框
#Include Lib\srf_Init.ahk		; 初始化
#Include Lib\srf_IME.ahk		; 找词、功能跳转、显示候选
#Include Lib\srf_Func.ahk	; 输入法上屏等函数
#Include Lib\srf_Option.ahk	; 选项界面
#Include Lib\Ciku_Manager.ahk   ; 词库管理界面
#Include Lib\functions.ahk	; 内置命令模块
#Include Lib\COPYDATA.ahk	; WM_COPYDATA进程间通信
#Include Lib\suanfa_pinyin.ahk	; 拼音类算法
#Include Lib\suanfa_sanma.ahk	; 三码类算法(2码+1辅助码)
#Include Lib\suanfa_xingma.ahk	; 形码类算法