﻿; ci_ku_Manager###############################################################################
cikuManager:
	OnMessage(0x200, "WM_MOUSEMOVE")
	alltablenames:="超级命令|魔法字符串|自定义短语|特殊符号", ENTabNames:={特殊符号:"symbol",自定义短语:"customs",拼音:"pinyin",五笔86:"wubi86",五笔98:"wubi98",超级命令:"functions",魔法字符串:"hotstrings",小鹤音形:"xiaohe"}
	CNColNames:={ROWID:"序号",key:"编码",value:"词条",weight:"权重",comment:"备注",pos:"位置"}
	If DB.GetTable("SELECT name FROM sqlite_master WHERE type='table' AND tbl_name NOT IN ('functions','hotstrings','customs','symbol','hebing','sqlite_sequence')",TableInfo){
		Loop % TableInfo.RowCount
			alltablenames .= "|" TableInfo.Rows[A_Index,1]
	}
	Gui, 97:Destroy
	Gui, 97:Default
	Gui, 97:+LastFound +OwnDialogs +hwndHGui97 ;+Disabled
	Gui, 97:Margin, 10, 10
	Gui, 97:Font, s11 Bold, %FontType%
	Gui, 97:Add, GroupBox, xm w780 h60, 词库管理
	Gui, 97:Font
	Gui, 97:Font, s11, %FontType%
	Gui, 97:Add, Button, xp+10 yp+20 w80 gWriteCiKu, 导入词库
	Gui, 97:Add, Button, xp+90 yp w80 gderiveCiKu, 导出词库
	Gui, 97:Add, Button, xp+90 yp w80 gDelCiku, 删除词库
	Gui, 97:Add, Button, xp+90 yp w80 gclearupCiku, 整理词库
	Gui, 97:Add, Button, xp+90 yp w80 gVacuum, 压缩词库
	Gui, 97:Add, Button, xp+90 yp w80 gdownloadCiku, 下载词库
	Gui, 97:Add, Button, xp+90 yp w80 ghelpciku, 使用帮助
	Gui, 97:Font
	Gui, 97:Font, s11 bold, %FontType%
	Gui, 97:Add, GroupBox, xm yp+40 w780 h445, 词条管理
	Gui, 97:Font
	Gui, 97:Font, s11, %FontType%
	Gui, 97:Add, Text, xm+10 yp+25 h20 w60 0x200, 选择词库:
	Gui, 97:Add, DropDownList, x+5 yp-5 w695 hp vTableName r10 gSwitchTable, %alltablenames%
	Gui, 97:Add, Text, xm+10 yp+35 w60 h20 0x200 vTX, 查找词条:
	Gui, 97:Add, Edit, x+5 yp-5 w695 vcitiao gSearch hwndhEdit
	Gui, 97:Add, ListView, xm+10 yp+30 w760 h350 vResultsLV -ReadOnly AltSubmit gSubLV1 hwndHLV1
	DllCall("UxTheme.dll\SetWindowTheme", "Ptr", HLV1, "Str", "Explorer", "Ptr", 0)
	DllCall("SendMessage", "Ptr", hEdit, "UInt", 0x1501, "Ptr", 1, "Str", "输入编码、词条、备注")
	; VarSetCapacity(CHANGEFILTERSTRUCT, 8, 0), NumPut(8, CHANGEFILTERSTRUCT), NumPut(0, CHANGEFILTERSTRUCT, 4)
	; DllCall("ChangeWindowMessageFilterEx", "UPtr", HGui97, "UInt", 0x0233, "UInt", 1, "UPtr", 0)
	WinSet Style, -0x40000000, ahk_id %hPic% ; -WS_CHILD
	Gui, 97:Add, StatusBar, gfysw
	SB_SetParts(80,450)
	Gui, 97:Font
	Gui, 97:Show, , 词库管理
	Menu, MyContextMenu, Add, 新建(&N), NewRow
	Menu, MyContextMenu, Add, 删除(&D), DelRow
	Menu, MyContextMenu, Add, 刷新(&R), Refresh
	Menu, BarMenu, Add, 100/页, fynumset
	Menu, BarMenu, Add, 500/页, fynumset
	Menu, BarMenu, Add, 1000/页, fynumset
	fynum:=100
	Menu, BarMenu, Check, %fynum%/页
	ICELV1:=New LV_InCellEdit(HLV1, True, True)
	Hotkey, IfWinActive, 词库管理
	Hotkey, Del, DelRow, On
	Hotkey, F5, Refresh, On
	; If (Inputscheme="")
	; 	GuiControl, 97:ChooseString, TableName, 超级命令
	; Else If (Inputscheme~="pinyin|sp$")
	; 	GuiControl, 97:ChooseString, TableName, pinyin
	; Else If InStr(alltablenames,Inputscheme)
	; 	GuiControl, 97:ChooseString, TableName, %Inputscheme%
	; Else
	; 	GuiControl, 97:ChooseString, TableName, 超级命令
	GuiControl, 97:ChooseString, TableName, 自定义短语
	Gosub SwitchTable
	GuiControl Focus, %hEdit%
	OnMessage(0x06, "WM_ACTIVATE")
	Return
	; #########################################   Gui事件   #####################################################
	vared:								; 热字串、词条生成编辑框
	Gui, vared:Destroy
	Gui, vared:+Resize +MinSize350x250 +Owner97 -MinimizeBox ;+AlwaysOnTop
	Gui, vared:Default
	Gui, vared:Add, Edit, vvaredtext r5 WantTab HWNDedhd
	Gui, vared:Add, Button, gSave, 确定
	MenuItem:=A_ThisMenuItem
	If (A_ThisMenuItem = "编辑(&E)"){
		Gui, vared:Show, NA w350 h250, 编辑
		GuiControl, , Edit1, %eddata%
	} Else If (A_ThisMenuItem = "魔法创建(&W)")
		Gui, vared:Show, NA w350 h250, 魔法创建
	Else
		Gui, vared:Show, NA w350 h250, 创建脚本
	ControlFocus, , ahk_id %edhd%
Return

fynumset:
	Menu, BarMenu, UnCheck, %fynum%/页
	fynum:=SubStr(A_ThisMenuItem,1,-2), yenum:=(RowsCt + fynum -1) // fynum
	Menu, BarMenu, Check, %A_ThisMenuItem%
	Gosub Refresh
Return

fysw:
	If (A_EventInfo=3)
		Menu, BarMenu, Show
Return

Save:								; 热字串、词条生成编辑框 g标签
	Gui, 97:Default
	Gui, vared:Submit
	Start:=A_TickCount
	If (MenuItem = "编辑(&E)"){
		If !(eddata == varedtext){
			LV_Modify(lastrow, "Col3", varedtext)
			If DB.Exec(_SQL:="UPDATE 'extend'.'" TableName "' SET value='" StrReplace(varedtext,"'","''") "'" " WHERE ROWID=" indexes[tv_index] ";")
				SB_SetText("更新词条"),SB_SetText("[" tv_index ",value] " eddata "-->" varedtext,2)
		}
	} Else If ((MenuItem = "魔法创建(&W)")&&(TableName = "hotstrings"))||((MenuItem = "创建脚本(&W)")&&(TableName = "functions")){
		If (TableName = "hotstrings"){
			DB.Exec("INSERT INTO 'extend'.'" TableName "' VALUES ('','" StrReplace(varedtext,"'","''") "','');")
		} Else
			DB.Exec("INSERT INTO 'extend'.'" TableName "' VALUES ('','" StrReplace(varedtext,"'","''") "','{Script}');")
		Loop {
			If !indexlist[A_Index] {
				tv_index:=A_Index
				indexlist[tv_index]:=True
				Break
			}
		}
		DB.GetTable("SELECT max(ROWID) FROM " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "'", Result)
		indexes[tv_index]:=Result.Rows[1][1]
		ControlGet, Focusedrow, List, Count Focused, , % "ahk_id " HLV1
		LV_Insert(Focusedrow + 1, "Select", tv_index, "", varedtext, (TableName="functions"?"{Script}":""))
		SB_SetText("插入词条"),SB_SetText("[" tv_index ",value] " varedtext,2)
		SB_SetText("已显示：" LV_GetCount() "/" (RowsCt+=1) "条",3)
	} Else
		Gosub citiao_create
Return

varedGuiSize:						; 热字串、词条生成编辑框自适应布局
	GuiControlGet, P, Pos, Button1
	GuiControl, Move, Button1, % "x" A_GuiWidth-10-PW "y" A_GuiHeight-6-PH
	GuiControl, Move, Edit1, % "w" A_GuiWidth-21 "h" A_GuiHeight-19-PH
Return

97GuiDropFiles:
	If (TableName!="functions"){
		GuiControl, 97:ChooseString, TableName, 超级命令
		Gosub SwitchTable
	}
	DB.GetTable("SELECT max(ROWID) FROM 'extend'.'functions'", Result)
	tvar:=Result.Rows[1][1]
	Loop, Parse, A_GuiEvent, `n, `r
	{
		SplitPath, A_LoopField, OutFileName
		If DB.Exec("INSERT INTO 'extend'.'functions' VALUES ('','" StrReplace(A_LoopField,"'","''") "','" StrReplace(OutFileName,"'","''") "');"){
			Loop {
				If !indexlist[A_Index] {
					tv_index:=A_Index
					indexlist[tv_index]:=True
					Break
				}
			}
			tvar++, indexes[tv_index]:=tvar
			ControlGet, Focusedrow, List, Count Focused, , % "ahk_id " HLV1
			LV_Insert(Focusedrow + 1, "", tv_index, "", A_LoopField, OutFileName)
			SB_SetText("插入词条"),SB_SetText("[" tv_index ",value] " A_LoopField,2)
			SB_SetText("已显示：" LV_GetCount() "/" (RowsCt+=1) "条",3)
		}
	}
Return

WM_ACTIVATE(wParam, lParam, msg, hwnd){
	global HGui97
	If (hwnd = HGui97)
		ToolTip
}

97GuiClose:
	OnMessage(0x200, "")
	ToolTip
	Gui, 97:Destroy
Return

97GuiContextMenu:					; CikuManager 列表右键菜单
	if (!TableName)||(A_GuiControl != "ResultsLV")||(Newflag)
		Return
	If lastrow:=LV_GetNext()
		Menu, MyContextMenu, Enable, 2&
	Else
		Menu, MyContextMenu, Disable, 2&
	If (TableName~="hotstrings|functions"){
		If lastrow {
			LV_GetText(tv_index, lastrow, 1)
			LV_GetText(eddata, lastrow, 3)
			Menu, MyContextMenu, Enable, 编辑(&E)
		} Else
			Menu, MyContextMenu, Disable, 编辑(&E)
	}
	Menu, MyContextMenu, Show, % A_GuiX*A_ScreenDPI/96, % A_GuiY*A_ScreenDPI/96
Return

SubLV1:								; CikuManager 列表编辑 g标签 修改、插入、删除。。。
	; Check for changes
	Critical
	If (A_GuiEvent == "f") {
		ControlGetText, olddata, Edit2, % "ahk_id " HGui97
		ControlGet, lastrow, List, Count Focused, , % "ahk_id " HLV1
		LV_GetText(tv_index, lastrow, 1)
	} Else If (A_GuiEvent == "F") {
		If Newflag {
			Newname:=""
			If (ICELV1["Changed"]){
				For Key, Value In ICELV1.Changed 									; 获取修改过的单元格对象
					Break
				ICELV1.Remove("Changed")

				Start:=A_TickCount, tkey:=""
				If (TableName~="^(pinyin|wubi86|wubi98)$")
					tkey:=StrSplit(IMEConverter(TableName,Value.Txt),"=","'")[1]
				If (TableName~="i)^(symbol|hotstrings|functions|customs)$")
					DB.Exec(_SQL:="INSERT INTO 'extend'.'" TableName "' VALUES ('','" StrReplace(Value.Txt,"'","''") "','');")
				Else {
					If (TableName="pinyin")
						_SQL:="INSERT INTO 'pinyin' VALUES (""" RegExReplace(tkey,"([a-z])[a-z]*","$1") """,""" tkey """,'" Value.Txt "',ifnull((SELECT max(weight) FROM 'pinyin' WHERE jp='" RegExReplace(tkey,"([a-z])[a-z]*","$1") "' AND key='" tkey "'),0)+1);"
					Else
						_SQL:="INSERT INTO '" TableName "' VALUES ('" tkey "','" Value.Txt "',ifnull((SELECT max(weight) FROM '" TableName "' WHERE key='" tkey "'),0)+1);"
					If !DB.Exec(_SQL)
						OutputDebug, % A_ThisLabel "|消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode "|" _SQL
				}
				Loop {
					If !indexlist[A_Index] {
						tv_index:=A_Index
						indexlist[tv_index]:=True
						Break
					}
				}
				LV_Modify(lastrow, "Col1", tv_index)
				LV_Modify(lastrow, "Col2", StrReplace(tkey,"''","'"))
				DB.GetTable("SELECT max(ROWID) FROM " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "'", Result)
				indexes[tv_index]:=Result.Rows[1][1]
				If !(TableName~="i)^(symbol|hotstrings|functions|customs)$"){
					DB.GetTable("SELECT weight FROM '" TableName "' WHERE ROWID=" Result.Rows[1][1], Result)
					LV_Modify(lastrow, "Col4", Result.Rows[1][1])
				}
				SB_SetText("插入词条"),SB_SetText("[" tv_index "," CNColNames["value"] "] " Value.Txt,2)
				SB_SetText("已显示：" LV_GetCount() "/" (RowsCt+=1) "条",3)
			} Else
				LV_Delete(lastrow)
			Newflag:=False
			If (TableColumns.Length()=0)
				Gosub Refresh
		} Else {
			If (ICELV1["Changed"])&&TableName {
				For Key, Value In ICELV1.Changed
					Break

				ICELV1.Remove("Changed")
				tvar:=Value.Txt
				Start:=A_TickCount
				If (tvar != olddata){
					If (Value.Col = 3){
						If DB.Exec(_SQL:="UPDATE " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "' SET " TableColumns[Value.Col] "='" StrReplace(tvar,"'","''") "'" " WHERE ROWID=" indexes[tv_index] ";")
							SB_SetText("更新词条"),SB_SetText("[" tv_index "," CNColNames[TableColumns[Value.Col]] "] " olddata "-->" tvar,2)
						Else
							OutputDebug, % A_ThisLabel "|消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode
					} Else If (Value.Col = 2){
						StringLower, tvar, tvar
						If (TableName = "pinyin"){
							tvar:=Trim(tvar,"'")
							If tvar {
								; If !InStr(tvar, "'")
									; tvar:=Trim(pyfenci(StrReplace(tvar, "'", ""),"pinyin"),"'")
								If (TableColumns[Value.Col]="key")
									DB.Exec(_SQL:="UPDATE '" TableName "' SET key='" StrReplace(tvar,"'","''") "',jp='" RegExReplace(StrReplace(tvar,"'","''"),"([a-z])[a-z]*","$1") "' WHERE ROWID=" indexes[tv_index] ";")
								Else
									DB.Exec(_SQL:="UPDATE '" TableName "' SET " TableColumns[Value.Col] "='" StrReplace(tvar,"'","''") "' WHERE ROWID=" indexes[tv_index] ";")
								LV_Modify(Value.Row, "Col" Value.Col, tvar)
								SB_SetText("更新词条"),SB_SetText("[" tv_index "," CNColNames[TableColumns[Value.Col]] "] " olddata "-->" tvar,2)
							} Else
								LV_Modify(Value.Row, "Col" Value.Col, olddata)
						} Else If (TableName = "symbol")||RegExMatch(tvar,"^;?[a-z]+$"){
							If DB.Exec(_SQL:="UPDATE " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "' SET " TableColumns[Value.Col] "='" StrReplace(tvar,"'","''") "'" " WHERE ROWID=" indexes[tv_index] ";"){
								; LV_Modify(Value.Row, "Col" Value.Col, tvar)
								SB_SetText("更新词条"),SB_SetText("[" tv_index "," CNColNames[TableColumns[Value.Col]] "] " olddata "-->" tvar,2)
							} Else
								OutputDebug, % A_ThisFunc "|消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode "|" DB.SQL
						} Else {
							LV_Modify(Value.Row, "Col" Value.Col, olddata)
							SB_SetText("key为小写字符串！！",2)
						}
					} Else If (Value.Col = 4){
						If (TableName ~= "i)^(symbol|hotstrings|functions|customs)$"){
							If DB.Exec(_SQL:="UPDATE 'extend'.'" TableName "' SET " TableColumns[Value.Col] "='" tvar "' WHERE ROWID=" indexes[tv_index] ";")
								SB_SetText("更新词条"),SB_SetText("[" tv_index "," CNColNames[TableColumns[Value.Col]] "] " olddata "-->" tvar,2)
						} Else {
							If RegExMatch(tvar,"^\d+(.\d+)?(e\+\d+)?$"){
								If DB.Exec(_SQL:="UPDATE '" TableName "' SET " TableColumns[Value.Col] "=" tvar " WHERE ROWID=" indexes[tv_index] ";")
									SB_SetText("更新词条"),SB_SetText("[" tv_index "," CNColNames[TableColumns[Value.Col]] "] " olddata "-->" tvar,2)
							} Else {
								LV_Modify(Value.Row, "Col" Value.Col, olddata)
								SB_SetText("weight为数值！！",2)
							}
						} 
					}
				}
			}
			LV_GetText(tvar, lastrow, 2)
			If (tvar~="[A-Z]")
				LV_Modify(lastrow, "Col2", Format("{:L}", tvar))
		}
	}
Return

NewRow:							; 新建行
	Gui, 97:Default
	ControlGet, Focusedrow, List, Count Focused, , % "ahk_id " HLV1
	LV_Insert(Focusedrow + 1, "Select", "", "", "")
	VarSetCapacity(RECT, 16, 0), NumPut(2, RECT, 4, "Int")			; 获取待插入单元格坐标并进入编辑状态
	SendMessage, 0x1038, % Focusedrow, % &RECT, , % "ahk_id " HLV1 ; LVM_GETSUBITEMRECT
	X0:=NumGet(RECT, 0, "Int")
	SendMessage, 0x1014, X0 - 100, 0, , % "ahk_id " HLV1 ; LVM_SCROLL
	VarSetCapacity(RECT, 16, 0), NumPut(2, RECT, 4, "Int")
	SendMessage, 0x1038, % Focusedrow, % &RECT, , % "ahk_id " HLV1 ; LVM_GETSUBITEMRECT
	X0:=NumGet(RECT, 0, "Int"), Y0:=NumGet(RECT, 4, "Int"), Point:=X0 + (Y0 << 16)
	Newflag:=True
	SendMessage, 0x0201, 0, % Point, , % "ahk_id " HLV1 ; WM_LBUTTONDOWN
	SendMessage, 0x0202, 0, % Point, , % "ahk_id " HLV1 ; WM_LBUTTONUP
	SendMessage, 0x0203, 0, % Point, , % "ahk_id " HLV1 ; WM_LBUTTONDBLCLK
	SendMessage, 0x0202, 0, % Point, , % "ahk_id " HLV1 ; WM_LBUTTONUP
Return

DelRow:							; 删除行
	Gui, 97:Default
	Gui +OwnDialogs
	ControlGetFocus, tvar
	If (tvar)&&(tvar!="SysListView321"){
		Send, {Del}
		Return
	}
	Start:=A_TickCount
	Firstrow:=LV_GetNext(), delrows:=[], Focusedrow:=0
	While Focusedrow:=LV_GetNext(Focusedrow) {
		LV_GetText(tv_index, Focusedrow, 1)
		If (DB.Exec("DELETE FROM " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "' WHERE ROWID='" indexes[tv_index] "';")){
			delrows.Push(Focusedrow)
			indexlist[tv_index]:=False, RowsCt--
		}
	}
	Loop % delrowsnum:=delrows.Length()
		LV_Delete(delrows[delrowsnum+1-A_Index])
	If delrowsnum {
		SB_SetText("删除词条"),SB_SetText("完成用时：" A_TickCount-Start " ms",2)
		SB_SetText("已显示：" LV_GetCount() "/" RowsCt "条",3)
		LV_Modify(Firstrow, "Select")
	}
Return

Refresh:							; 刷新
	Gui, 97:Default
	SB_SetText("获取数据库"),SB_SetText("",2),SB_SetText("",3)
	Start:=A_TickCount
	If DB.GetTable(RegExReplace(fy_SQL,"^SELECT .+ FROM","SELECT COUNT(*) FROM"), Result)
		RowsCt:=Result.Rows[1][1]
	If !DB.GetTable(fy_SQL "LIMIT " yepos*fynum "," fynum, Result)
		MsgBox, 16, SQLite错误, % "消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode
	SB_SetText("展示词条")
	ShowTable(Result)
	SB_SetText("展示词条"),SB_SetText("完成用时：" (A_TickCount - Start) " ms",2)
	SB_SetText("已显示：" (yenum>1?yepos*fynum+1 "-" yepos*fynum+Min(fynum,LV_GetCount()) "/" RowsCt:RowsCt "/" RowsCt) "条",3)
	Sleep, 100
	; Gosub GetTable
Return

DelCiku:
	Gui, 97:Submit, NoHide
	Gui +OwnDialogs
	MsgBox, 308, 删除词库, 确实要永久性地删除此词库吗？`n%TableName%
	IfMsgBox, No
		Return
	TableName:=ENTabNames[TableName]?ENTabNames[TableName]:TableName
	_SQL:="DROP TABLE " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "'"
	Start:=A_TickCount
	If (DB.Exec(_SQL)){
		GuiControl, -ReDraw, ResultsLV
		LV_Delete()
		GuiControl, +ReDraw, ResultsLV
		RowsCt:=0, _SQL:=""
		SB_SetText("删除词库"),SB_SetText("完成用时：" (A_TickCount - Start) " ms",2)
		SB_SetText("",3)
		If !(TableName~="^(hotstrings|functions|customs|symbol)$"){
			alltablenames:=StrReplace(StrReplace(alltablenames,TableName),"||","|"), TableName:=""
			GuiControl, 97:, TableName, % "|" Trim(alltablenames,"|")
		}
		; DB.Exec("VACUUM")
	}
	indexlist:=[],RowsCt:=0
Return

clearupCiku:
	If !TableName
		Return
	SB_SetText("数据合并整理"),SB_SetText("准备数据去重...",2),Start:=A_TickCount
	remaketable(DB,TableName)
	Gosub GetTable
	SB_SetText("整理完毕，完成用时 " A_TickCount - Start " ms",2)
	; DB.Exec("VACUUM")
Return

helpciku:
	Run https://gitee.com/orz707/shadow/wikis/词库类别
	; Gui +OwnDialogs
	; helptip=
	; (LTrim
	; 导入词库：数据文件是以待导入的词库名为前缀的文本文档(如wubi86_1.txt;zhengma.txt)，推荐编码为UTF-8-BOM。数据内容按顺序包括键码key、内容value、权重weight或备注comment(非必须)，以=或Tab或空格分隔。导入pinyin、wubi86、wubi98词库时，键码key非必须，可自动生成。各行格式一致，格式如下：
	; aaaa=恭恭敬敬=劳斯莱斯=花花草草 （无weight）
	; ggtt=五笔
	; pin'yin=拼音=16
	; 影子输入法=20

	; hotstrings、functions格式如下,换行\n Tab\t：
	; ["key","value","comment"]

	; 查找词条：百分号（`%）代表零个、一个或多个数字或字符。
	; 下划线（_）代表一个数字或字符。这些符号可以被组合使用。查询结果大于1页时，右下角菜单设置每页显示词条数，翻页快捷键
	; 前一页：PgUp`t后一页：PgDn
	; 选中时按Del删除当前行
	; 双击单元格进入编辑模式。修改时切换单元格快捷键：
	; 上：Up`t下：Down`t左：Shift Tab`t右：Tab

	; 整理词库：导入、创建完词条后，使用此功能能合并重复项，提高检索效率。

	; hotstrings(comment项)：无{...}关键字或{Input}{Text} 文本模式(默认)；{Fast}粘贴模式，大段文字输入时速度快；{Delay,10,10}延时模式；{}键击模式，速度较慢，如：!{F4}；
	; functions(comment项)：默认Run模式，comment内容为显示名；脚本模式，在comment中加入{Script}关键字；{Ev}，使用Everything搜索文件并打开；返回值模式{Value}，脚本中加入 FileAppend, `%var`%, * ，执行脚本后显示返回var值。
	; 可拖动文件到functions窗口快速创建Run模式命令（管理员权限运行时无法创建）。
	; )
	; MsgBox, 64, 使用帮助, %helptip%
Return

#IfWinActive 词库管理
	PgUp::
	PgDn::
	fanye:
	Gui +OwnDialogs
	Gui, 97:Default
	If (A_ThisHotkey="PgDn"){
		If yepos+1<yenum
			yepos+=1
		Else
			Return
	} Else {
		If yepos-1>=0
			yepos-=1
		Else
			Return
	}
	Gosub Refresh
	Return
#If

Search:
	SetTimer, GetTable, -200
Return

SwitchTable:
	Gui, 97:Default
	Gui, 97:Submit, NoHide
	TableName:=ENTabNames[TableName]?ENTabNames[TableName]:TableName
	Loop 2
		Try 
			Menu, MyContextMenu, Delete, 4&
	If (TableName="hotstrings"){
		Menu, MyContextMenu, Add, 编辑(&E), vared
		Menu, MyContextMenu, Add, 魔法创建(&W), vared
	} Else If (TableName="functions"){
		Menu, MyContextMenu, Add, 编辑(&E), vared
		Menu, MyContextMenu, Add, 创建脚本(&W), vared
	} Else If (TableName~="wubi86|wubi98|pinyin"){
		Menu, MyContextMenu, Add, 魔法创建(&W), vared
	}
	Gosub GetTable
Return

GetTable:
	Gui +OwnDialogs
	Gui, 97:Default
	Gui, 97:Submit, NoHide
	global RowsCt
	If (TableName="")
		Return
	TableName:=ENTabNames[TableName]?ENTabNames[TableName]:TableName
	; If (TableName="pinyin")&&RegExMatch(citiao, "^([a-z]+)$")
		; citiao:=Trim(pyfenci(citiao, , True, DB),"'")
	citiao:=StrReplace(citiao, "'", "''"), fy_SQL:="", operate:=(RegExMatch(citiao,"_|%")?"LIKE":"=")
	If (TableName="pinyin")
		fy_SQL:="SELECT ROWID,key,value,weight FROM 'pinyin'" (citiao?" WHERE " (RegExMatch(citiao, "^([a-z'_%]+)$")?(RegExMatch(citiao, "^([_%]+)$")?"value " operate "'" citiao "' OR":"jp " operate " '" RegExReplace(citiao,"([a-z])[a-z_]*","$1") "' AND") " key " operate " '" citiao "'":"value " operate " '" citiao "'"):"") " ORDER BY " (citiao?"key,weight":"ROWID") " DESC "
	Else If (TableName~="hotstrings|functions|symbol")
		fy_SQL:="SELECT ROWID,key,value,comment FROM 'extend'.'" TableName "'" (citiao?" WHERE " (RegExMatch(citiao, "^([a-z;_%]+)$")?"key " operate " '" citiao "' OR value " operate "'" citiao "' OR comment " operate "'" citiao "'":"value " operate " '" citiao "' OR comment " operate "'" citiao "'"):"") " ORDER BY " (citiao?"key ":"ROWID DESC ")
	Else If (TableName="customs")
		fy_SQL:="SELECT ROWID,key,value,comment FROM 'extend'.'customs'" (citiao?" WHERE " (RegExMatch(citiao, "^([a-z;'_%]+)$")?"key " operate " '" citiao "' OR value " operate "'" citiao "'":"value " operate " '" citiao "'"):"") " ORDER BY " (citiao?"key ":"ROWID DESC ")
	Else
		fy_SQL:="SELECT ROWID,key,value,weight FROM '" TableName "'" (citiao?" WHERE " (RegExMatch(citiao, "^([a-z;'_% ]+)$")?"key " operate " '" citiao "'" (!(citiao~="[a-z]")?" OR value " operate "'" citiao "'":""):"value " operate " '" citiao "'"):"") " ORDER BY " (citiao?"key,weight DESC ":"ROWID DESC ")

	SB_SetText("获取数据库"),SB_SetText("",2),SB_SetText("",3)
	If DB.GetTable(RegExReplace(fy_SQL,"^SELECT .+ FROM","SELECT COUNT(*) FROM"), Result){
		RowsCt:=Result.Rows[1][1]
		yenum:=(Result.Rows[1][1] + fynum -1) // fynum						; 分页查询
	} Else {
		RowsCt:=0, tv_index:=0
		If (TableName ~= "functions|hotstrings|symbol|customs")
			_SQL = CREATE TABLE "extend"."%TableName%" ("key" TEXT,"value" TEXT,"comment" TEXT);
		Else If (TableName="pinyin")
			_SQL = CREATE TABLE "pinyin" ("jp" TEXT,"key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 1);
		Else
			_SQL = CREATE TABLE "%TableName%" ("key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 1);
		DB.Exec(_SQL)
		If (TableName="pinyin")
			DB.Exec("CREATE INDEX IF NOT EXISTS ""sy_pinyin"" ON ""pinyin"" (""jp"");")
		Else
			DB.Exec("CREATE INDEX IF NOT EXISTS " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.":"") """sy_" TableName """ ON """ TableName """ (""key"");")
	}
	Result:=""
	Start:=A_TickCount,yepos:=0
	If !DB.GetTable(fy_SQL " LIMIT 0," fynum, Result)
		MsgBox, 16, SQLite错误, % "消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode
	SB_SetText("展示词条")
	ShowTable(Result)
	SB_SetText("展示词条"),SB_SetText("完成用时：" (A_TickCount - Start) " ms",2)
	SB_SetText("已显示：" (yenum>1?1 "-" LV_GetCount() "/" RowsCt:RowsCt "/" RowsCt) "条",3)
Return

ShowTable(Table){
	global
	local ColCount, RowCount, Row
	GuiControl, 97:-ReDraw, ResultsLV
	LV_Delete(), indexes:=[], indexlist:=[] 
	ColCount:=LV_GetCount("Column")
	Loop, %ColCount%
		LV_DeleteCol(1)
	If (Table.HasNames){
		TableColumns:=Table.ColumnNames
		; Loop % Max(Table.ColumnNames.Length(),1)
		; 	LV_InsertCol(A_Index, "100", CNColNames[TableColumns[A_Index]])
		LV_InsertCol(1, "40", CNColNames[TableColumns[1]])
		LV_InsertCol(2, "80", CNColNames[TableColumns[2]])
		LV_InsertCol(3, "500", CNColNames[TableColumns[3]])
		LV_InsertCol(4, "100 Integer", CNColNames[TableColumns[4]])
		ICELV1.SetColumns(2,3,4)					; 设置key，value，weight列可编辑
		ICELV1.OnMessage()
		If (Table.HasRows){
			Loop, % Table.RowCount 
			{
				RowCount:=LV_Add("", "")
				Table.Next(Row)
				LV_Modify(RowCount, "Col1", A_Index)
				indexlist[A_Index]:=True
				indexes[A_Index]:=Row[1]
				Loop, % Table.ColumnCount - 1
				{
					LV_Modify(RowCount, "Col" A_Index+1, Row[A_Index+1])
				}
			}
		}
		; LV_ModifyCol(1, "AutoHdr", CNColNames[TableColumns[1]])
	}
	GuiControl, 97:+ReDraw, ResultsLV
}

citiao_create(TableName, str){
	global DB
	Gui, 97:Default
	index:=0, tvar:="", start:=A_TickCount
	SB_SetText("魔法创建"),SB_SetText("创建词条中 ...",2),SB_SetText("",3)
	DB.Exec("BEGIN TRANSACTION;")
	Loop, Parse, str, `n, `r
	{
		If (A_LoopField="")
			Continue
		hang:=A_LoopField
		RegExMatch(hang, "^([a-zA-Z]['a-zA-Z]*)", tkey)						; 查找key
		hang:=StrReplace(hang, tkey)
		RegExMatch(hang, "(\d+)", tcipin)							; 查找词频
		hang:=StrReplace(hang, tcipin)
		RegExMatch(hang, "O)([^\x00-\xff]+)", tcizu, 1)				; 查找双字节字符
		If !tcizu.Value[1]
			Continue
		If !tkey
			tvar .= tcizu.Value[1] (tcipin?"=" tcipin:"") "`n"
		Else {
			StringLower, tkey, % Trim(tkey,"'")
			If (TableName = "pinyin"){
				If !InStr(tkey, "'")									; 未分词的分词处理
					tkey:=Trim(pyfenci(tkey,"pinyin"),"'")
			} Else
				tkey:=StrReplace(tkey,"'","")
			If (TableName="pinyin")
				DB.Exec("INSERT INTO 'pinyin' VALUES (""" RegExReplace(tkey, "([a-z])[a-z]*", "$1") """,""" tkey """,'" tcizu.Value[1] "'," (tcipin?tcipin:"ifnull((SELECT max(weight) FROM 'pinyin' WHERE jp=""" RegExReplace(tkey,"([a-z])[a-z]*","$1") """ AND key=""" tkey """),0)+1") ")")
			Else
				DB.Exec("INSERT INTO '" TableName "' VALUES ('" tkey "','" tcizu.Value[1] "'," (tcipin?tcipin:"ifnull((SELECT max(weight) FROM '" TableName "' WHERE key='" tkey "'),0)+1") ")")
		}
		While RegExMatch(A_LoopField, "O)([^\x00-\xff]+)", tcizu, tcizu.pos[1]+tcizu.len[1]){			; 查找双字节字符加入待转序列
			If !tkey
				tvar .= tcizu.Value[1] (tcipin?"=" tcipin:"") "`n"
			Else {
				tkey:=StrReplace(tkey,"'","''")
				If (TableName="pinyin")
					DB.Exec("INSERT INTO 'pinyin' VALUES ('" RegExReplace(tkey, "([a-z])[a-z]*", "$1") "','" tkey "','" tcizu.value[1] "'," (tcipin?tcipin:"ifnull((SELECT max(weight) FROM 'pinyin' WHERE jp=""" RegExReplace(tkey,"([a-z])[a-z]*","$1") """ AND key=""" tkey """),0)+1") ")")
				Else
					DB.Exec("INSERT INTO '" TableName "' VALUES ('" tkey "','" tcizu.value[1] "'," (tcipin?tcipin:"ifnull((SELECT max(weight) FROM '" TableName "' WHERE key='" tkey "'),0)+1") ")")
			}
		}
	}
	If tvar&&(TableName ~= "pinyin|wubi86|wubi98") {							; 转换成拼音、wubi86
		tvar:=IMEConverter(TableName,tvar)
		Loop, Parse, tvar, `n, `r
		{
			If (A_LoopField=="")
				Continue
			tarr:=StrSplit(A_LoopField,"=","'")
			If (TableName="pinyin")
				DB.Exec("INSERT INTO 'pinyin' VALUES(""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """,""" tarr[1] """,'" tarr[2] "'," (tarr[3]?tarr[3]:"ifnull((SELECT max(weight) FROM 'pinyin' WHERE jp=""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """ AND key=""" tarr[1] """),0)+1") ")")
			Else
				DB.Exec("INSERT INTO '" TableName "' VALUES('" tarr[1] "','" tarr[2] "'," (tarr[3]?tarr[3]:"ifnull((SELECT max(weight) FROM '" TableName "' WHERE key='" tarr[1] "'),0)+1") ")")
		}
	}
	tvar:="",tarr:=""
	If (TableName="pinyin")
		DB.Exec("CREATE INDEX IF NOT EXISTS ""sy_pinyin"" ON ""pinyin"" (""jp"");")
	Else
		DB.Exec("CREATE INDEX IF NOT EXISTS ""sy_" TableName """ ON """ TableName """ (""key"");")
	DB.Exec("COMMIT TRANSACTION;")
	Gosub Refresh
	SB_SetText("创建完毕，完成用时 " A_TickCount - Start " ms",2)
}
citiao_create:							; 全拼、wubi86词条自动生成拼音
	citiao_create(TableName, varedtext)
Return

WriteCiKu:
	; ======================================================================================================================
	; 导入词库
	; ======================================================================================================================
	Gui +OwnDialogs
	FileSelectFile, MaBiaoFile, 3, , 导入词库, Text Documents (*.txt)
	SplitPath, MaBiaoFile, , , , filename
	If (MaBiaoFile = ""){
		SB_SetText("取消导入",2)
		Return
	} Else {
		SB_SetText("选择了词库：" MaBiaoFile,2), SB_SetText("",3)
	}
	RegExMatch(filename, "^[^_]+",filename)
	If !(filename)
		Return
	Else If (filename~="sp$"){
		MsgBox, 52, 提示, 导入的文件名前缀不能以sp结尾！
		Return
	}
	MsgBox, 52, 提示, 要导入以下词库？`n%filename%
	IfMsgBox, No
	{
		SB_SetText("取消导入",2)
		Return
	} Else {
		TableName:=ENTabNames[filename]?ENTabNames[filename]:Format("{:L}", filename)
		If DB.GetTable("SELECT COUNT(*) FROM  " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") TableName "'", Result){
			If Result.Rows[1][1] {
				MsgBox, 308, 注意, 是否合并词库？
				IfMsgBox No
					Return
			}
		}
		If (!InStr(TableName, "@"))&&!InStr(alltablenames "|", "|" TableName "|")&&!(TableName~="^(hotstrings|functions|customs|symbol)$"){
			alltablenames .= "|" TableName
			GuiControl, 97:, TableName, %TableName%
		}
		GuiControl, 97:ChooseString, TableName, % (TableName="hotstrings"?"魔法字符串":TableName="functions"?"超级命令":TableName="customs"?"自定义短语":TableName="symbol"?"特殊符号":TableName)
		Gosub SwitchTable
		LV_Delete()
	}
	SB_SetText("词库导入"),SB_SetText("读取文件...",2),SB_SetText("",3)
	Start:=A_TickCount
	; ======================================================================================================================
	; #######################################词组拼音生成导入###########################
	; ======================================================================================================================
	FileRead, MaBiao, %MaBiaoFile%
	If !(TableName~="hotstrings|functions")
		RegExMatch(MaBiao:=Trim(MaBiao," `n`r"), "[\t =]", delimiter)
	delimiter:=(delimiter~="^(\t|=| )$"?delimiter:"=")
	If (TableName~="pinyin|wubi86|wubi98")&&(RegExMatch(MaBiao, "^[^\x00-\x7e]+(=\d+)?")){
		SB_SetText("转换词库中，请稍后...",2),SB_SetText("",3)
		CopyOfData:=""
		MaBiao:=IMEConverter(TableName,MaBiao,delimiter)
	}
	SB_SetText("词库写入中，请稍后...",2)
	If writeDB(DB,TableName,MaBiao,delimiter,1)
		SB_SetText("写入失败",2)
	Else
		SB_SetText("写入完毕，完成用时 " A_TickCount - Start " ms",2)
Return

deriveCiKu:													; 导出词库
	Gui +OwnDialogs
	Gui, 97:Default
	Gui, 97:Submit, NoHide
	MsgBox, 64, 导出词库, % "导出：" TableName "`n共" RowsCt "条"
	TableName:=ENTabNames[TableName]?ENTabNames[TableName]:TableName
	start:=A_TickCount
	SB_SetText("词库导出"),SB_SetText("导出中...",2)
	DeriveFromDB(DB, TableName, fy_SQL)
	SB_SetText("导出完毕"),SB_SetText("完成用时：" A_TickCount - start " ms，备份文件在：" A_ScriptDir "目录",2)
Return

DeriveFromDB(DB, TableName, _SQL, timestamp:=""){
	If (_SQL="")
		Return
	Result:="", outputword:="", RowsCt:=0
	timestamp:=timestamp?timestamp:A_Now
	If DB.GetTable(RegExReplace(RegExReplace(_SQL," ORDER BY.+"),"i)^SELECT .+ FROM","SELECT COUNT(*) FROM"), Result)
		RowsCt:=Result.Rows[1][1]
	Loop % (RowsCt+100000-1)//100000
	{
		If DB.GetTable(_SQL " LIMIT " 100000*(A_Index-1) ",100000", Result){
			SB_SetText("读取数据完毕，写入备份文件……",2)
			If (TableName="symbol"){
				Loop % Result.RowCount
					outputword .= Result.Rows[A_Index,2] "=" Result.Rows[A_Index,3] "=" Result.Rows[A_Index,4] "`n"
			} Else If (TableName~="hotstrings|functions"){
				Loop % Result.RowCount
					outputword .= JSON.Dump([Result.Rows[A_Index,2], Result.Rows[A_Index,3], Result.Rows[A_Index,4]]) "`n"
			} Else {
				Loop % Result.RowCount
					outputword .= Result.Rows[A_Index,2] "=" Result.Rows[A_Index,3] "=" Result.Rows[A_Index,4] "`n"
			}
			FileAppend,%outputword%,%TableName%_%timestamp%.txt, UTF-8
			Result:=outputword:=""
		}
	}
}

downloadCiku:
	Run, https://www.autoahk.com/archives/16339
	Run, https://pan.baidu.com/s/1ZTJym45A1wgcaBQ4d_fCvQ
Return

writeDB(DB, TableName, ByRef MaBiao, delimiter:="=", TRANSACTION:=0){
	If (TRANSACTION){
		DB.Exec("BEGIN TRANSACTION;")
		DB.Exec("DROP INDEX IF EXISTS " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.":"") "'sy_" TableName "';")
	}
	If (TableName ~= "i)^(symbol|hotstrings|functions|customs)$")
		_SQL = CREATE TABLE IF NOT EXISTS "extend"."%TableName%" ("key" TEXT,"value" TEXT,"comment" TEXT);
	Else If (TableName="pinyin")
		_SQL = CREATE TABLE IF NOT EXISTS "pinyin" ("jp" TEXT,"key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 0);
	Else
		_SQL = CREATE TABLE IF NOT EXISTS "%TableName%" ("key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 0);
	DB.Exec(_SQL)
	index:=0, _SQL:=""
	If (TableName="pinyin"){
		Loop, Parse, MaBiao, `n, `r
		{
			If (A_LoopField = "")
				Continue
			tarr:=StrSplit(A_LoopField,delimiter)
			tarr[1]:=Format("{:L}", tarr[1])
			If (tarr[3]="")
				index++, _SQL .= "`nINSERT INTO 'pinyin' VALUES(""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """,""" tarr[1] """,'" tarr[2] "',1);"
			Else If (tarr[3]~="^\d+(\.\d+)?")
				index++, _SQL .= "`nINSERT INTO 'pinyin' VALUES(""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """,""" tarr[1] """,'" tarr[2] "'," tarr[3] ");"
			Else {
				tvar:=tarr.Length()
				Loop % tvar-2
					_SQL .= "`nINSERT INTO 'pinyin' VALUES(""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """,""" tarr[1] """,'" tarr[A_Index+1] "'," tvar-A_Index ");"
				index++, _SQL .= "`nINSERT INTO 'pinyin' VALUES(""" RegExReplace(tarr[1],"([a-z])[a-z]*","$1") """,""" tarr[1] """,'" tarr.Pop() "',1);"
			}
			If (index>199)
				DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
		}
		; DB.Exec("UPDATE 'pinyin' SET weight=weight-(SELECT min(weight) from 'pinyin') WHERE weight<0")
	} Else If (TableName~="hotstrings|functions"){
		Loop, Parse, MaBiao, `n, `r
		{
			If (A_LoopField = "")
				Continue
			Try {
				tarr:=JSON.Load(A_LoopField)
				index++, _SQL .= "`nINSERT INTO 'extend'.'" TableName  "' VALUES('" Format("{:L}", tarr[1]) "','" StrReplace(tarr[2],"'","''") "','" tarr[3] "');"
			}
			If (index>199)
				DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
		}
	} Else If (TableName="customs"){
		Loop, Parse, MaBiao, `n, `r
		{
			If (A_LoopField = "")
				Continue
			tarr:=StrSplit(A_LoopField,delimiter)
			If (tarr[3]="")
				index++, _SQL .= "`nINSERT INTO 'extend'.'customs' VALUES('" tarr[1] "','" StrReplace(tarr[2],"'","''") "','001');"
			Else If (tarr[3]~="^\d+(\{.*\})?")
				index++, _SQL .= "`nINSERT INTO 'extend'.'customs' VALUES('" tarr[1] "','" StrReplace(tarr[2],"'","''") "','" tarr[3] "');"
			Else {
				tvar:=tarr.Length()
				Loop % tvar-1
					index++, _SQL .= "`nINSERT INTO 'extend'.'customs' VALUES('" tarr[1] "','" StrReplace(tarr[A_Index+1],"'","''") "','" Format("{:03}", A_Index) "');"
			}
			If (index>199)
				DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
		}
	} Else If (TableName="symbol"){
		Loop, Parse, MaBiao, `n, `r
		{
			If (A_LoopField = "")
				Continue
			tarr:=StrSplit(A_LoopField,delimiter)
			index++, _SQL .= "`nINSERT INTO 'extend'.'symbol' VALUES('" tarr[1] "','" StrReplace(tarr[2],"'","''") "','" tarr[3] "');"
			If (index>199)
				DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
		}
	} Else {
		Loop, Parse, MaBiao, `n, `r
		{
			If (A_LoopField = "")
				Continue
			tarr:=StrSplit(A_LoopField,delimiter)
			If (tarr[3]="")
				index++, _SQL .= "`nINSERT INTO '" TableName "' VALUES('" tarr[1] "','" tarr[2] "',1);"
			Else If (tarr[3]~="^\d+(\.\d+)?")
				index++, _SQL .= "`nINSERT INTO '" TableName "' VALUES('" tarr[1] "','" tarr[2] "'," tarr[3] ");"
			Else {
				tvar:=tarr.Length()
				Loop % tvar-2
					index++, _SQL .= "`nINSERT INTO '" TableName "' VALUES('" tarr[1] "','" tarr[A_Index+1] "'," (tvar-A_Index) ");"
				index++, _SQL .= "`nINSERT INTO '" TableName "' VALUES('" tarr[1] "','" tarr.Pop() "',1);"
			}
			If (index>199)
				DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
		}
	}
	If (index)
		DB.Exec(LTrim(_SQL,"`n")), index:=0, _SQL:=""
	MaBiao:=""
	If (TRANSACTION){
		If (TableName="pinyin")
			DB.Exec("CREATE INDEX IF NOT EXISTS ""sy_pinyin"" ON ""pinyin"" (""jp"");")
		Else If (TableName~="i)^(symbol|hotstrings|functions|customs)$")
			DB.Exec("CREATE INDEX IF NOT EXISTS 'extend'.""sy_" TableName """ ON """ TableName """ (""key"");")
		Else
			DB.Exec("CREATE INDEX IF NOT EXISTS ""sy_" TableName """ ON """ TableName """ (""key"");")
		If !DB.Exec("COMMIT TRANSACTION;"){
			MsgBox, 16, 数据库错误, % "消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode
			DB.Exec("ROLLBACK;")
			Return 1
		}
	}
}

Vacuum:
	SB_SetText("压缩词库"),SB_SetText("压缩中...",2),SB_SetText("",3),Start:=A_TickCount
	DB.Exec("Vacuum " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'":"'main'"))
	SB_SetText("压缩完成"),SB_SetText("完成用时：" A_TickCount-Start "ms",2)
Return
; ci_ku_Manager###############################################################################

; sqlite首字母函数
shouzimu(Context, ArgC, Values){
	; sqlite自定义函数 key生成首字母简拼函数 wo''men --> w''m
	result:=""
	If (ArgC = 1){
		AddrN := DllCall("SQLite3.dll\sqlite3_value_text", "Ptr", NumGet(Values + 0, "UPtr"), "Cdecl UPtr")
		result:=RegExReplace(StrGet(AddrN, "UTF-8"), "([a-z])[a-z]*", "$1")
	}
	DllCall("SQLite3.dll\sqlite3_result_text", "Ptr", Context, "AStr", result, "Int", StrLen(result), "Ptr", 0, "Cdecl")
}
; 
remaketable(DB,Name){
	If !Name
		Return
	DB.Exec("DROP TABLE IF EXISTS " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.":"") "'hebing';")
	DB.Exec("BEGIN TRANSACTION;")
	If (Name~="^(hotstrings|functions|symbol|customs)$")
		_SQL = CREATE TABLE 'extend'.'hebing' ("key" TEXT,"value" TEXT,"comment" TEXT);
	Else If (Name="pinyin")
		_SQL = CREATE TABLE 'hebing' ("jp" TEXT,"key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 0);
	Else
		_SQL = CREATE TABLE 'hebing' ("key" TEXT,"value" TEXT,"weight" INTEGER DEFAULT 0);
	DB.Exec(_SQL)
	If (Name~="^(hotstrings|functions|symbol|customs)$")
		_SQL:="INSERT INTO 'extend'.'hebing' SELECT key,value,comment FROM 'extend'.'" Name "' GROUP by key,value ORDER by key;"
	Else If (Name="pinyin")
		_SQL:="INSERT INTO 'hebing' SELECT jp,key,value,max(weight) FROM 'pinyin' GROUP by key,value ORDER BY jp,key,4 DESC;"
	Else
		_SQL:="INSERT INTO 'hebing' SELECT key,value,max(weight) FROM '" Name "' GROUP by key,value ORDER by key,3 DESC;"
	If DB.Exec(_SQL)
		DB.Exec("DROP TABLE " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") Name "';ALTER TABLE " (TableName~="i)^(symbol|hotstrings|functions|customs)$"?"'extend'.'":"'") "hebing' RENAME TO '" Name "';")
	Else
		MsgBox % A_ThisLabel "|消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode "|" _SQL
	If (Name="pinyin")
		_SQL = CREATE INDEX IF NOT EXISTS "sy_%Name%" ON "%Name%" ("jp");
	Else If (Name~="i)^(symbol|hotstrings|functions|customs)$")
		_SQL = CREATE INDEX IF NOT EXISTS "extend"."sy_%Name%" ON "%Name%" ("key");
	Else
		_SQL = CREATE INDEX IF NOT EXISTS "sy_%Name%" ON "%Name%" ("key");
	DB.Exec(_SQL)
	DB.Exec("COMMIT TRANSACTION;")
}

; 编码生成函数
IMEConverter(Method,Str,delimiter:="="){
	global srf_Plugins
	DetectHiddenWindows, on
	If (srf_Plugins["IMEConverter",1]=""){
		Run, % "Lib\IMEConverter.exe " DllCall("GetCurrentProcessId") " " (tGUID:=CreateGUID()), , , tPID
		WinWait, % "ahk_pid" tPID, , 5
		srf_Plugins["IMEConverter",1]:=tPID, srf_Plugins["IMEConverter",2]:=tGUID
		Sleep 1000
	} Else {
		Process, Exist, % srf_Plugins["IMEConverter",1]
		If (!ErrorLevel){
			Run, % "Lib\IMEConverter.exe " DllCall("GetCurrentProcessId") " " (srf_Plugins["IMEConverter",2]?srf_Plugins["IMEConverter",2]:(srf_Plugins["IMEConverter",2]:=CreateGUID())), , , tPID
			WinWait, % "ahk_pid" tPID, , 5
			srf_Plugins["IMEConverter",1]:=tPID
			Sleep 1000
		}
	}
	If (ErrorLevel=srf_Plugins["IMEConverter",1])||(ErrorLevel=0){
		Return ComObjActive(srf_Plugins["IMEConverter",2]).Converter(Method, Str, delimiter)
		; Timeout:=CopyOfData:=""
		; EnvAdd, Timeout, 4, Seconds
		; OutputDebug, Send_WM_COPYDATA
		; ret:=Send_WM_COPYDATA(Method Chr(4) Str,"ahk_class AutoHotkey ahk_pid" IMEConverterPID)
		; If (ret=0)
   		; 	Return 1
		; Else If (ret="FAIL"){
		; 	If (A_Now<Timeout)
		; 		Return 0
		; 	Else {
		; 		Loop {
		; 			Process, Exist, %IMEConverterPID%
		; 			If (ErrorLevel=IMEConverterPID){
		; 				If (CopyOfData="")
		; 					Sleep, 100
		; 				Else
		; 					Return 1
		; 			} Else
		; 				Return 0
		; 		}
		; 	}
		; }
	} Else
		Return
}
; ======================================================================================================================
; Namespace:      LV_InCellEdit (ListView列表单元格编辑类)
; Function:       Support for in-cell ListView editing.
; Tested with:    AHK 1.1.22.09 (1.1.20+ required)
; Tested on:      Win 10 Pro (x64)
; Change History: 1.2.02.00/2015-12-14/just me - Bug fix and support for centered columns.
;                 1.2.01.00/2015-09-08/just me - Added EditUserFunc option.
;                 1.2.00.00/2015-03-29/just me - New version based on AHK 1.1.20+ features.
;                 1.1.04.00/2014-03-22/just me - Added method EditCell
;                 1.1.03.00/2012-05-05/just me - Added back option BlankSubItem for method Attach
;                 1.1.02.00/2012-05-01/just me - Added method SetColumns
;                 1.1.01.00/2012-03-18/just me
; ======================================================================================================================
; CLASS LV_InCellEdit
;
; Unlike other in-cell editing scripts, this class is using the ListViews built-in edit control.
; Advantage:
;     You don't have to care about the font and the GUI, and most of the job can be done by handling common ListView
;     notifications.
; Disadvantage:
;     I've still found no way to prevent the ListView from blanking out the first subitem of the row while editing
;     another subitem. The only known workaround is to add a hidden first column.
;
; The class provides methods to restrict editing to certain columns, to directly start editing of a specified cell,
; and to deactivate/activate the built-in message handler for WM_NOTIFY messages (see below).
;
; The message handler for WM_NOTIFY messages will be activated for the specified ListView whenever a new instance is
; created. As long as the message handler is activated a double-click on any cell will show an Edit control within this
; cell allowing to edit the current content. The default behavior for editing the first column by two subsequent single
; clicks is disabled. You have to press "Esc" to cancel editing, otherwise the content of the Edit will be stored in
; the current cell. ListViews must have the -ReadOnly option to be editable.
;
; While editing, "Esc", "Tab", "Shift+Tab", "Down", and "Up" keys are registered as hotkeys. "Esc" will cancel editing
; without changing the value of the current cell. All other hotkeys will store the content of the edit in the current
; cell and continue editing for the next (Tab), previous (Shift+Tab), upper (Up), or lower (Down) cell. You cannot use
; the keys for other purposes while editing.
;
; All changes are stored in MyInstance.Changed. You may track the changes by triggering (A_GuiEvent == "F") in the
; ListView's gLabel and checking MyInstance["Changed"] as shown in the sample scipt. If "True", MyInstance.Changed
; contains an array of objects with keys "Row" (row number), "Col" (column number), and "Txt" (new content).
; Changed is one of the two keys intended to be accessed directly from outside the class.
;
; If you want to temporarily disable in-cell editing call MyInstance.OnMessage(False). This must be done also before
; you try to destroy the instance. To enable it again, call MyInstance.OnMessage().
;
; To avoid the loss of Gui events and messages the message handler might need to be 'critical'. This can be
; achieved by setting the instance property 'Critical' to the required value (e.g. MyInstance.Critical:=100).
; New instances default to 'Critical, Off'. Though sometimes needed, ListViews or the whole Gui may become
; unresponsive under certain circumstances if Critical is set and the ListView has a g-label.
; ======================================================================================================================
Class LV_InCellEdit {
	; Instance properties -----------------------------------------------------------------------------------------------
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; META FUNCTIONS ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; ===================================================================================================================
	; __New()         Creates a new LV_InCellEdit instance for the specified ListView.
	; Parameters:     HWND           -  ListView's HWND
	;                 Optional ------------------------------------------------------------------------------------------
	;                 HiddenCol1     -  ListView with hidden first column
	;                                   Values:  True / False
	;                                   Default: False
	;                 BlankSubItem   -  Blank out subitem's text while editing
	;                                   Values:  True / False
	;                                   Default: False
	;                 EditUserFunc   -  The name of a user-defined funtion to be called from
	;                                   LVN_BEGINEDITLABEL and LVN_ENDEDITLABEL.
	;                                   The function must accept at least 6 Parameters:
	;                                      State -  The state of the edit operation: BEGIN / END
	;                                      HLV   -  The handle to the ListView.
	;                                      HED   -  The handle to the edit control.
	;                                      Row   -  The row number of the edited item.
	;                                      Col   -  The column number of the edited item.
	;                                      Text  -  The edited item's text before / after editing.
	;                                   To avoid the loss of messages the function should Return as soon as possible.
	; ===================================================================================================================
	__New(HWND, HiddenCol1:=False, BlankSubItem:=False, EditUserFunc:="") {
		If (This.Base.Base.__Class) ; do not instantiate instances
			Return False
		If This.Attached[HWND] ; HWND is already attached
			Return False
		If !DllCall("IsWindow", "Ptr", HWND) ; invalid HWND
			Return False
		VarSetCapacity(Class, 512, 0)
		DllCall("GetClassName", "Ptr", HWND, "Str", Class, "Int", 256)
		If (Class <> "SysListView32") ; HWND doesn't belong to a ListView
			Return False
		If (EditUserFunc <> "") && (Func(EditUserFunc).MaxParams < 6)
			Return False
		; ----------------------------------------------------------------------------------------------------------------
		; Set LVS_EX_DOUBLEBUFFER (0x010000) style to avoid drawing issues.
		SendMessage, 0x1036, 0x010000, 0x010000, , % "ahk_id " . HWND ; LVM_SETEXTENDEDLISTVIEWSTYLE
		This.HWND:=HWND
		This.HEDIT:=0
		This.Item:=-1
		This.SubItem:=-1
		This.ItemText:=""
		This.RowCount:=0
		This.ColCount:=0
		This.Cancelled:=False
		This.Next:=False
		This.Skip0:=!!HiddenCol1
		This.Blank:=!!BlankSubItem
		This.Critical:="Off"
		This.DW:=0
		This.EX:=0
		This.EY:=0
		This.EW:=0
		This.EH:=0
		This.LX:=0
		This.LY:=0
		This.LR:=0
		This.LW:=0
		This.SW:=0
		If (EditUserFunc <> "")
			This.EditUserFunc:=Func(EditUserFunc)
		This.OnMessage()
		This.Attached[HWND]:=True
	}
	; ===================================================================================================================
	__Delete() {
		This.Attached.Remove(This.HWND, "")
		WinSet, Redraw, , % "ahk_id " . This.HWND
	}
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; PUBLIC INTERFACE ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; ===================================================================================================================
	; EditCell        Edit the specified cell, if possible.
	; Parameters:     Row   -  1-based row number
	;                 Col   -  1-based column number
	;                          Default: 0 - edit the first editable column
	; Return values:  True on success; otherwise False
	; ===================================================================================================================
	EditCell(Row, Col:=0) {
		If !This.HWND
			Return False
		ControlGet, Rows, List, Count, , % "ahk_id " . This.HWND
		This.RowCount:=Rows - 1
		ControlGet, ColCount, List, Count Col, , % "ahk_id " . This.HWND
		This.ColCount:=ColCount - 1
		If (Col = 0) {
			If (This["Columns"])
				Col:=This.Columns.MinIndex() + 1
			ELse If This.Skip0
				Col:=2
			Else
				Col:=1
		}
		If (Row < 1) || (Row > Rows) || (Col < 1) || (Col > ColCount)
			Return False
		If (Column = 1) && This.Skip0
			Col:=2
		If (This["Columns"])
			If !This.Columns[Col - 1]
				Return False
		VarSetCapacity(LPARAM, 1024, 0)
		NumPut(Row - 1, LPARAM, (A_PtrSize * 3) + 0, "Int")
		NumPut(Col - 1, LPARAM, (A_PtrSize * 3) + 4, "Int")
		This.NM_DBLCLICK(&LPARAM)
		Return True
	}
	; ===================================================================================================================
	; SetColumns      Sets the columns you want to edit
	; Parameters:     ColNumbers* -  zero or more numbers of column which shall be editable. If entirely omitted,
	;                                the ListView will be reset to enable editing of all columns.
	; Return values:  True on success; otherwise False
	; ===================================================================================================================
	SetColumns(ColNumbers*) {
		If !This.HWND
			Return False
		This.Remove("Columns")
		If (ColNumbers.MinIndex() = "")
			Return True
		ControlGet, ColCount, List, Count Col, , % "ahk_id " . This.HWND
		Indices:=[]
		For Each, Col In ColNumbers {
			If Col Is Not Integer
				Return False
			If (Col < 1) || (Col > ColCount)
				Return False
			Indices[Col - 1]:=True
		}
		This["Columns"]:=Indices
		Return True
	}
	; ===================================================================================================================
	; OnMessage       Activate / deactivate the message handler for WM_NOTIFY messages for this ListView
	; Parameters:     Apply    -  True / False
	;                             Default: True
	; Return Value:   Always True
	; ===================================================================================================================
	OnMessage(Apply:=True) {
		If !This.HWND
			Return False
		If (Apply) && !This.HasKey("NotifyFunc") {
			This.NotifyFunc:=ObjBindMethod(This, "On_WM_NOTIFY")
			OnMessage(0x004E, This.NotifyFunc) ; add the WM_NOTIFY message handler
		}
		Else If !(Apply) && This.HasKey("NotifyFunc") {
			OnMessage(0x004E, This.NotifyFunc, 0) ; remove the WM_NOTIFY message handler
			This.NotifyFunc:=""
			This.Remove("NotifyFunc")
		}
		WinSet, Redraw, , % "ahk_id " . This.HWND
		Return True
	}
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; PRIVATE PROPERTIES ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; Class properties --------------------------------------------------------------------------------------------------
	Static Attached:={}
	Static OSVersion:=DllCall("GetVersion", "UChar")
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; PRIVATE METHODS +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; -------------------------------------------------------------------------------------------------------------------
	; WM_COMMAND message handler for edit notifications
	; -------------------------------------------------------------------------------------------------------------------
	On_WM_COMMAND(W, L, M, H) {
		; LVM_GETSTRINGWIDTHW = 0x1057, LVM_GETSTRINGWIDTHA = 0x1011
		Critical, % This.Critical
		If (L = This.HEDIT) {
			N:=(W >> 16)
			If (N = 0x0400) || (N = 0x0300) || (N = 0x0100) { ; EN_UPDATE | EN_CHANGE | EN_SETFOCUS
				If (N = 0x0100) ; EN_SETFOCUS
					SendMessage, 0x00D3, 0x01, 0, , % "ahk_id " . L ; EM_SETMARGINS, EC_LEFTMARGIN
				ControlGetText, EditText, , % "ahk_id " . L
				SendMessage, % (A_IsUnicode ? 0x1057 : 0x1011), 0, % &EditText, , % "ahk_id " . This.HWND
				EW:=ErrorLevel + This.DW
				, EX:=This.EX
				, EY:=This.EY
				, EH:=This.EH + (This.OSVersion < 6 ? 3 : 0) ; add 3 for WinXP
				If (EW < This.MinW)
					EW:=This.MinW
				If (EX + EW) > This.LR
					EW:=This.LR - EX
				DllCall("SetWindowPos", "Ptr", L, "Ptr", 0, "Int", EX, "Int", EY, "Int", EW, "Int", EH, "UInt", 0x04)
				If (N = 0x0400) ; EN_UPDATE
					Return 0
			}
		}
	}
	; -------------------------------------------------------------------------------------------------------------------
	; WM_HOTKEY message handler
	; -------------------------------------------------------------------------------------------------------------------
	On_WM_HOTKEY(W, L, M, H) {
		; LVM_CANCELEDITLABEL = 0x10B3, Hotkeys: 0x801B  (Esc -> cancel)
		If (H = This.HWND) {
			If (W = 0x801B) { ; Esc
				This.Cancelled:=True
				PostMessage, 0x10B3, 0, 0, , % "ahk_id " . H
			}
			; Else {
			; 	This.Next:=True
			; 	SendMessage, 0x10B3, 0, 0, , % "ahk_id " . H
			; 	This.Next:=True
			; 	This.NextSubItem(W)
			; }
			Return False
		}
	}
	; -------------------------------------------------------------------------------------------------------------------
	; WM_NOTIFY message handler
	; -------------------------------------------------------------------------------------------------------------------
	On_WM_NOTIFY(W, L) {
		Critical, % This.Critical
		If (H:=NumGet(L + 0, 0, "UPtr") = This.HWND) {
			M:=NumGet(L + (A_PtrSize * 2), 0, "Int")
			; BeginLabelEdit -------------------------------------------------------------------------------------------------
			If (M = -175) || (M = -105) ; LVN_BEGINLABELEDITW || LVN_BEGINLABELEDITA
				Return This.LVN_BEGINLABELEDIT(L)
			; EndLabelEdit ---------------------------------------------------------------------------------------------------
			If (M = -176) || (M = -106) ; LVN_ENDLABELEDITW || LVN_ENDLABELEDITA
				Return This.LVN_ENDLABELEDIT(L)
			; Double click ---------------------------------------------------------------------------------------------------
			If (M = -3) ; NM_DBLCLICK
				This.NM_DBLCLICK(L)
		}
	}
	; -------------------------------------------------------------------------------------------------------------------
	; LVN_BEGINLABELEDIT notification
	; -------------------------------------------------------------------------------------------------------------------
	LVN_BEGINLABELEDIT(L) {
		Static Indent:=4   ; indent of the Edit control, 4 seems to be reasonable for XP, Vista, and 7
		If (This.Item = -1) || (This.SubItem = -1)
			Return True
		H:=This.HWND
		SendMessage, 0x1018, 0, 0, , % "ahk_id " . H ; LVM_GETEDITCONTROL
		This.HEDIT:=ErrorLevel
		, VarSetCapacity(ItemText, 2048, 0) ; text buffer
		, VarSetCapacity(LVITEM, 40 + (A_PtrSize * 5), 0) ; LVITEM structure
		, NumPut(This.Item, LVITEM, 4, "Int")
		, NumPut(This.SubItem, LVITEM, 8, "Int")
		, NumPut(&ItemText, LVITEM, 16 + A_PtrSize, "Ptr") ; pszText in LVITEM
		, NumPut(1024 + 1, LVITEM, 16 + (A_PtrSize * 2), "Int") ; cchTextMax in LVITEM
		SendMessage, % (A_IsUnicode ? 0x1073 : 0x102D), % This.Item, % &LVITEM, , % "ahk_id " . H ; LVM_GETITEMTEXT
		This.ItemText:=StrGet(&ItemText, ErrorLevel)
		; Call the user function, if any
		If (This.EditUserFunc)
			This.EditUserFunc.Call("BEGIN", This.HWND, This.HEDIT, This.Item + 1, This.Subitem + 1, This.ItemText)
		SendMessage, 0x000C, 0, % &ItemText, , % "ahk_id " . This.HEDIT
		If (This.SubItem > 0) && (This.Blank) {
			Empty:=""
			, NumPut(&Empty, LVITEM, 16 + A_PtrSize, "Ptr") ; pszText in LVITEM
			, NumPut(0,LVITEM, 16 + (A_PtrSize * 2), "Int") ; cchTextMax in LVITEM
			SendMessage, % (A_IsUnicode ? 0x1074 : 0x102E), % This.Item, % &LVITEM, , % "ahk_id " . H ; LVM_SETITEMTEXT
		}
		VarSetCapacity(RECT, 16, 0)
		, NumPut(This.SubItem, RECT, 4, "Int")
		SendMessage, 0x1038, This.Item, &RECT, , % "ahk_id " . H ; LVM_GETSUBITEMRECT
		This.EX:=NumGet(RECT, 0, "Int") + Indent
		, This.EY:=NumGet(RECT, 4, "Int")
		If (This.OSVersion < 6)
			This.EY -= 1 ; subtract 1 for WinXP
		If (This.SubItem = 0) {
			SendMessage, 0x101D, 0, 0, , % "ahk_id " . H ; LVM_GETCOLUMNWIDTH
			This.EW:=ErrorLevel
		}
		Else
			This.EW:=NumGet(RECT, 8, "Int") - NumGet(RECT, 0, "Int")
		This.EH:=NumGet(RECT, 12, "Int") - NumGet(RECT, 4, "Int")
		; Check the column alignement
		VarSetCapacity(LVCOL, 56, 0)
		, NumPut(1, LVCOL, "UInt") ; LVCF_FMT
		SendMessage, % (A_IsUnicode ? 0x105F : 0x1019), % This.SubItem, % &LVCOL, , % "ahk_id " . H ; LVM_GETCOLUMN
		If (NumGet(LVCOL, 4, "UInt") & 0x0002) { ; LVCFMT_CENTER
			SendMessage, % (A_IsUnicode ? 0x1057 : 0x1011), 0, % &ItemText, , % "ahk_id " . This.HWND ; LVM_GETSTRINGWIDTH
			EW:=ErrorLevel + This.DW
			If (EW < This.MinW)
				EW:=This.MinW
			If (EW < This.EW)
				This.EX += ((This.EW - EW) // 2) - Indent
		}
		; Register WM_COMMAND handler
		This.CommandFunc:=ObjBindMethod(This, "On_WM_COMMAND")
		, OnMessage(0x0111, This.CommandFunc)
		; Register hotkeys
		If !(This.Next)
			This.RegisterHotkeys()
		This.Cancelled:=False
		This.Next:=False
		Return False
	}
	; -------------------------------------------------------------------------------------------------------------------
	; LVN_ENDLABELEDIT notification
	; -------------------------------------------------------------------------------------------------------------------
	LVN_ENDLABELEDIT(L) {
		H:=This.HWND
		; Unregister WM_COMMAND handler
		OnMessage(0x0111, This.CommandFunc, 0)
		This.CommandFunc:=""
		; Unregister hotkeys
		If !(This.Next)
			This.RegisterHotkeys(False)
		ItemText:=This.ItemText
		If !(This.Cancelled)
			ControlGetText, ItemText, , % "ahk_id " . This.HEDIT
		If (ItemText <> This.ItemText) {
			If !(This["Changed"])
				This.Changed:=[]
			This.Changed.Insert({Row: This.Item + 1, Col: This.SubItem + 1, Txt: ItemText})
		}
		; Restore subitem's text if changed or blanked out
		If (ItemText <> This.ItemText) || ((This.SubItem > 0) && (This.Blank)) {
			VarSetCapacity(LVITEM, 40 + (A_PtrSize * 5), 0) ; LVITEM structure
			, NumPut(This.Item, LVITEM, 4, "Int")
			, NumPut(This.SubItem, LVITEM, 8, "Int")
			, NumPut(&ItemText, LVITEM, 16 + A_PtrSize, "Ptr") ; pszText in LVITEM
			SendMessage, % (A_IsUnicode ? 0x1074 : 0x102E), % This.Item, % &LVITEM, , % "ahk_id " . H ; LVM_SETITEMTEXT
		}
		If !(This.Next)
			This.Item:=This.SubItem:=-1
		This.Cancelled:=False
		This.Next:=False
		; Call the user function, if any
		If (This.EditUserFunc)
			This.EditUserFunc.Call("END", This.HWND, This.HEDIT, This.Item + 1, This.Subitem + 1, ItemText)
		Return False
	}
	; -------------------------------------------------------------------------------------------------------------------
	; NM_DBLCLICK notification
	; -------------------------------------------------------------------------------------------------------------------
	NM_DBLCLICK(L) {
		H:=This.HWND
		This.Item:=This.SubItem:=-1
		Item:=NumGet(L + (A_PtrSize * 3), 0, "Int")
		SubItem:=NumGet(L + (A_PtrSize * 3), 4, "Int")
		If (This["Columns"]) {
			If !This["Columns", SubItem]
				Return False
		}
		If (Item >= 0) && (SubItem >= 0) {
			This.Item:=Item, This.SubItem:=SubItem
			If !(This.Next) {
				ControlGet, V, List, Count, , % "ahk_id " . H
				This.RowCount:=V - 1
				ControlGet, V, List, Count Col, , % "ahk_id " . H
				This.ColCount:=V - 1
				, NumPut(VarSetCapacity(WINDOWINFO, 60, 0), WINDOWINFO)
				, DllCall("GetWindowInfo", "Ptr", H, "Ptr", &WINDOWINFO)
				, This.DX:=NumGet(WINDOWINFO, 20, "Int") - NumGet(WINDOWINFO, 4, "Int")
				, This.DY:=NumGet(WINDOWINFO, 24, "Int") - NumGet(WINDOWINFO, 8, "Int")
				, Styles:=NumGet(WINDOWINFO, 36, "UInt")
				SendMessage, % (A_IsUnicode ? 0x1057 : 0x1011), 0, % "WWW", , % "ahk_id " . H ; LVM_GETSTRINGWIDTH
				This.MinW:=ErrorLevel
				SendMessage, % (A_IsUnicode ? 0x1057 : 0x1011), 0, % "III", , % "ahk_id " . H ; LVM_GETSTRINGWIDTH
				This.DW:=ErrorLevel
				, SBW:=0
				If (Styles & 0x200000) ; WS_VSCROLL
					SysGet, SBW, 2
				ControlGetPos, LX, LY, LW, , , % "ahk_id " . H
				This.LX:=LX
				, This.LY:=LY
				, This.LR:=LX + LW - (This.DX * 2) - SBW
				, This.LW:=LW
				, This.SW:=SBW
				, VarSetCapacity(RECT, 16, 0)
				, NumPut(SubItem, RECT, 4, "Int")
				SendMessage, 0x1038, %Item%, % &RECT, , % "ahk_id " . H ; LVM_GETSUBITEMRECT
				X:=NumGet(RECT, 0, "Int")
				If (SubItem = 0) {
					SendMessage, 0x101D, 0, 0, , % "ahk_id " . H ; LVM_GETCOLUMNWIDTH
					W:=ErrorLevel
				}
				Else
					W:=NumGet(RECT, 8, "Int") - NumGet(RECT, 0, "Int")
				R:=LW - (This.DX * 2) - SBW
				If (X < 0)
					SendMessage, 0x1014, % X, 0, , % "ahk_id " . H ; LVM_SCROLL
				Else If ((X + W) > R)
					SendMessage, 0x1014, % (X + W - R + This.DX), 0, , % "ahk_id " . H ; LVM_SCROLL
			}
			PostMessage, % (A_IsUnicode ? 0x1076 : 0x1017), %Item%, 0, , % "ahk_id " . H ; LVM_EDITLABEL
		}
		Return False
	}
	; -------------------------------------------------------------------------------------------------------------------
	; Next subItem
	; -------------------------------------------------------------------------------------------------------------------
	NextSubItem(K) {
		; Hotkeys: 0x8009 (Tab -> right), 0x8409 (Shift+Tab -> left), 0x8028  (Down -> down), 0x8026 (Up -> up)
		; Find the next subitem
		H:=This.HWND
		Item:=This.Item
		SubItem:=This.SubItem
		If (K = 0x8009) ; right
			SubItem++
		Else If (K = 0x8409) { ; left
			SubItem--
			If (SubItem = 0) && This.Skip0
				SubItem--
		}
		Else If (K = 0x8028) ; down
			Item++
		Else If (K = 0x8026) ; up
			Item--
		IF (K = 0x8409) || (K = 0x8009) { ; left || right
			If (This["Columns"]) {
				If (SubItem < This.Columns.MinIndex())
					SubItem:=This.Columns.MaxIndex(), Item--
				Else If (SubItem > This.Columns.MaxIndex())
					SubItem:=This.Columns.MinIndex(), Item++
				Else {
					While (This.Columns[SubItem] = "") {
						If (K = 0x8009) ; right
							SubItem++
						Else
							SubItem--
					}
				}
			}
		}
		If (SubItem > This.ColCount)
			Item++, SubItem:=This.Skip0 ? 1 : 0
		Else If (SubItem < 0)
			SubItem:=This.ColCount, Item--
		If (Item > This.RowCount)
			Item:=0
		Else If (Item < 0)
			Item:=This.RowCount
		If (Item <> This.Item)
			SendMessage, 0x1013, % Item, False, , % "ahk_id " . H ; LVM_ENSUREVISIBLE
		VarSetCapacity(RECT, 16, 0), NumPut(SubItem, RECT, 4, "Int")
		SendMessage, 0x1038, % Item, % &RECT, , % "ahk_id " . H ; LVM_GETSUBITEMRECT
		X:=NumGet(RECT, 0, "Int"), Y:=NumGet(RECT, 4, "Int")
		If (SubItem = 0) {
			SendMessage, 0x101D, 0, 0, , % "ahk_id " . H ; LVM_GETCOLUMNWIDTH
			W:=ErrorLevel
		}
		Else
			W:=NumGet(RECT, 8, "Int") - NumGet(RECT, 0, "Int")
		R:=This.LW - (This.DX * 2) - This.SW, S:=0
		If (X < 0)
			S:=X
		Else If ((X + W) > R)
			S:=X + W - R + This.DX
		If (S)
			SendMessage, 0x1014, % S, 0, , % "ahk_id " . H ; LVM_SCROLL
		Point:=(X - S + (This.DX * 2)) + ((Y + (This.DY * 2)) << 16)
		SendMessage, 0x0201, 0, % Point, , % "ahk_id " . H ; WM_LBUTTONDOWN
		SendMessage, 0x0202, 0, % Point, , % "ahk_id " . H ; WM_LBUTTONUP
		SendMessage, 0x0203, 0, % Point, , % "ahk_id " . H ; WM_LBUTTONDBLCLK
		SendMessage, 0x0202, 0, % Point, , % "ahk_id " . H ; WM_LBUTTONUP
	}
	; -------------------------------------------------------------------------------------------------------------------
	; Register/UnRegister hotkeys
	; -------------------------------------------------------------------------------------------------------------------
	RegisterHotkeys(Register = True) {
		; WM_HOTKEY:=0x0312, MOD_SHIFT:=0x0004
		; Hotkeys: 0x801B  (Esc -> cancel, 0x8009 (Tab -> right), 0x8409 (Shift+Tab -> left)
		;          0x8028  (Down -> down), 0x8026 (Up -> up)
		H:=This.HWND
		If (Register) { ; Register
			DllCall("RegisterHotKey", "Ptr", H, "Int", 0x801B, "UInt", 0, "UInt", 0x1B)
			, DllCall("RegisterHotKey", "Ptr", H, "Int", 0x8009, "UInt", 0, "UInt", 0x09)
			, DllCall("RegisterHotKey", "Ptr", H, "Int", 0x8409, "UInt", 4, "UInt", 0x09)
			, DllCall("RegisterHotKey", "Ptr", H, "Int", 0x8028, "UInt", 0, "UInt", 0x28)
			, DllCall("RegisterHotKey", "Ptr", H, "Int", 0x8026, "UInt", 0, "UInt", 0x26)
			, This.HotkeyFunc:=ObjBindMethod(This, "On_WM_HOTKEY")
			, OnMessage(0x0312, This.HotkeyFunc) ; WM_HOTKEY
		}
		Else { ; Unregister
			DllCall("UnregisterHotKey", "Ptr", H, "Int", 0x801B)
			, DllCall("UnregisterHotKey", "Ptr", H, "Int", 0x8009)
			, DllCall("UnregisterHotKey", "Ptr", H, "Int", 0x8409)
			, DllCall("UnregisterHotKey", "Ptr", H, "Int", 0x8028)
			, DllCall("UnregisterHotKey", "Ptr", H, "Int", 0x8026)
			, OnMessage(0x0312, This.HotkeyFunc, 0) ; WM_HOTKEY
			, This.HotkeyFunc:=""
		}
	}
}