﻿srf_init:
	;读取配置
	global srf_default_value, mhyRegExstr, YzIni:=class_EasyIni("yz.ini"), DllFolder:=A_ScriptDir "\Lib\Dll_" (A_PtrSize=4?"x86":"x64")
	srf_default_value:={Settings:{Startingup:0, Autoupdatefg:1, Adminfg:1, CloudInput:0, fuzhuma:0, SendDelay:0, SendFromClip:0, Imagine:0, Magicstring:0, Superrun:0, Wordfrequency:0
		, Learning:0, Inputscheme:"pinyin", chaojijp:0, Traditional:0, Showquanpin:0, Source:"aliyun", mhy_ch:0, mhy_sh:0, mhy_zh:0, mhy_ang:0, mhy_eng:0, mhy_ing:0
		, pinyinhunsu:0, simasp:1, wumaqc:1, wumasp:1, Different:0, IMEmode:1, IMECnWindows:"", IMEEnWindows:"", EnChar:0, EnSymbol:0, SaveCloud:0, ShowCode:0, Singleword:0}
		, Func:{CustomFuncName:"{""label"":""l"",""magic"":""s"",""mode"":""m"",""run"":""r"",""scheme"":""sc"",""soso"":""ss""}"}
		, GuiStyle:{FontType:"Microsoft YaHei UI", FontSize:20, TextColor:"FFFFFF", BackgroundColor:"006697", ListNum:5, Textdirection:"Horizontal"
		, LogoSize:100, ToolTipStyle:(A_OSVersion="WIN_XP"?1:2), Lockedposition:0}
		, Hotkey:{Double:0, Switch:"LShift", Enterfg:2, Escfg:1, Shiftfg:2, fanyefg:"[],-="}
		, DBFile:{main:"Lib\ciku.db", extend:"Lib\ciku_extend.db"}
		, Version:{Version:"1.1.0"}}
	For Section, element In srf_default_value
		For Key, Value In element
			If ((%Key%:=YzIni[Section, Key])="")
				%Key%:=YzIni[Section, Key]:=Value
	If Adminfg&&!(A_IsAdmin || RegExMatch(DllCall("GetCommandLine", "Str"), " /restart(?!\S)")){
		Try	{
			If A_IsCompiled
				Run *RunAs "%A_ScriptFullPath%" /restart
			Else
				Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
		}
		ExitApp
	} Else If (A_IsAdmin)
		YzIni.Settings["Adminfg"]:=1
	yzPID:=DllCall("GetCurrentProcessId")
	FileDelete, temp32.exe
	FileDelete, temp64.exe
	If (Source="Gitee")
		Sourceurl:="https://gitee.com/orz707/shadow/raw/master"
	Else
		Sourceurl:="https://autohotkey.oss-cn-qingdao.aliyuncs.com/AutoAHKScript/Scripts/yz"
	If !FileExist(DllFolder "\SQLite3.dll"){
		Progress, B2 ZH-1 ZW-1 FS12, %DllFolder%\SQLite3.dll不存在！`n正在下载，请稍后...
		If !URLDownloadToFile(A_PtrSize=4?Sourceurl "/Lib/Dll_x86/SQLite3.dll":"https://autohotkey.oss-cn-qingdao.aliyuncs.com/AutoAHKScript/Scripts/yz/Lib/Dll_x64/SQLite3.dll", DllFolder "\SQLite3.dll"){
			Progress, Off
			MsgBox, 16, 错误, SQLite3.dll下载失败！`n请手动下载后放在%DllFolder%。
			ExitApp
		}
		Progress, Off
	}
	If !InStr(ListFonts(),FontType)
		FontType:=YzIni["GuiStyle","FontType"]:="宋体"
	mhyRegExstr:=(mhy_zh?"z":"") (mhy_sh?"s":"") (mhy_ch?"c":"") (mhy_ang?"a":"") (mhy_eng?"e":"") (mhy_ing?"i":"")
	shurulei:=(Inputscheme~="sp$|pinyin"?"pinyin":Inputscheme="sanma"?"sanma":"xingma")
	valueindex:=Traditional?5:2, SendDelaymode:=(SendFromClip?"{Fast" (SendDelay?"," SendDelay*10:"") "}":(SendDelay?"{Delay," SendDelay*10 ",0}":""))
	application_name:="影子输入法" (A_PtrSize=4?"32位":"64位")
	Yz_Abort:="影子输入法是由河许人和天黑请闭眼联合开发的简单、简洁、高度自定义输入法。影子输入法起源于AutoHotkey高手群 Hello_srf开发的柚子输入法,融合了承影和jip输入法的理念。 影子输入法为开源、绿色、安全的输入法。请放心使用!"
	waitnum:=srf_mode:=Learnfg:=0, learn_words:=[], ClipSaved:="", HasEmojiFont:=InStr(ListFonts(), "Segoe UI Emoji")
	Gosub module_functions
	srf_Custom_Func:=""
	If (CustomFuncName~="{.+}")
		Try srf_Custom_Func:=JSON.Load(CustomFuncName)
	If !IsObject(srf_Custom_Func)
		srf_Custom_Func:={}
	pinyince:={"全拼":"pinyin","小鹤双拼":"xhsp","自然码双拼":"zrmsp","ABC双拼":"abcsp","搜狗双拼":"sgsp","微软双拼":"wrsp"}
	pinyinec:={}, AppIMEtable:={}, history_field_array:={}, save_field_array:={}, SQL_buffer:={}, srf_Plugins:={}, srf_last_input:={}
	For Key,Value In pinyince
		pinyinec[Value]:=Key
	If (!FileExist("Lib\yz.icl"))
		URLDownloadToFile("https://autohotkey.oss-cn-qingdao.aliyuncs.com/AutoAHKScript/Scripts/yz/Lib/yz.icl", "Lib\yz.icl")
	If (!FileExist(main)){
		tvar:=1
		If (FileExist("ciku_demo.db")){
			FileMove, ciku_demo.db, Lib\ciku.db
			If (ErrorLevel){
				Try	{
					If A_IsCompiled
						Run *RunAs "%A_ScriptFullPath%" /restart
					Else
						Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
				}
				ExitApp
			}
		} Else {
			Run, https://www.autoahk.com/archives/15117
			Progress, B2 ZH-1 ZW-1 FS12, 正在下载词库ciku.db
			URLDownloadToFile("https://autohotkey.oss-cn-qingdao.aliyuncs.com/AutoAHKScript/Scripts/yz/ciku_demo.db", main)
			Progress, Off
		}
	}
	If (!FileExist("Lib\IMEConverter.exe"))
		URLDownloadToFile(Sourceurl "/Lib/IMEConverter.exe", "Lib\IMEConverter.exe")
	If (!FileExist("Lib\CloudInput.exe"))
		URLDownloadToFile(Sourceurl "/Lib/IMEConverter.exe", "Lib\CloudInput.exe")

	;画主窗口
	Gosub TRAYMENU
	Gosub LoadLogo
	Gosub ChangeDB
	Gosub Registrationhotkey
	Gosub houxuankuangguicreate
	Gosub Registrationfuncandlabel
	If (tvar){
		Gosub cikuManager
		Gosub Option
		Gosub Help
	}
	If Autoupdatefg
		SetTimer, srfAutoupdatefg, -2000
	If (fuzhuma)	; 载入辅助码
		Gosub Loadfuzhuma
	If (Different)
		SetTimer, AppImeAutoSwitch, 100
	If (CloudInput&&Inputscheme~="pinyin|sp$")
		Try	{
			Run, % "Lib\CloudInput.exe " DllCall("GetCurrentProcessId"), , , tvar
			srf_Plugins["CloudInput",1]:=tvar
		}
	; 插件自启动
	; Loop, Files, %A_ScriptDir%\Lib\YzPlugins\*.ahk
	; 	RunPlugins(A_LoopFileLongPath)
Return

AppImeAutoSwitch:
	WinGetClass, activeclass, A
	WinGet, activeexe, ProcessName, A
	WinGet, activepid, PID, A
	If (activeclass="tooltips_class32")||(activepid=yzPID)||(history_activepid=activepid)
		Return
	If (history_activepid)&&(WinExist("ahk_pid" history_activepid)=0x0){
		If (history_activepid!="")
			AppIMEtable.RemoveAt(history_activepid)
	} Else
		AppIMEtable[history_activepid]:=srf_mode
	Switch (checkactivewindow(activeclass,activeexe)^srf_mode)
	{
		Case 1:
			Gosub srfSwitch
		Case -1:
			If (AppIMEtable[activepid]=""){
				AppIMEtable[activepid]:=IMEmode-1
				If (srf_mode!=IMEmode-1)
					Gosub srfSwitch
			} Else If (AppIMEtable[activepid]!=srf_mode)
				Gosub srfSwitch
	}
	; If ((t:=checkactivewindow(activeclass,activeexe)^srf_mode)>-1){
	; 	If t
	; 		Gosub srfSwitch
	; } Else If (AppIMEtable[activepid]=""){
	; 	AppIMEtable[activepid]:=IMEmode-1
	; 	If (srf_mode!=IMEmode-1)
	; 		Gosub srfSwitch
	; } Else If (AppIMEtable[activepid]!=srf_mode)
	; 	Gosub srfSwitch
	history_activepid:=activepid
Return
checkactivewindow(arr*){
	global IMECnWindows,IMEEnWindows
	If (IMEEnWindows)
		For Key,Value In arr
			If Value In %IMEEnWindows%
				Return 0
	If (IMECnWindows)
		For Key,Value In arr
			If Value In %IMECnWindows%
				Return 1
	Return -1
}

ChangeDB:
	DB.GetTable("SELECT sql FROM sqlite_master WHERE type='table' AND tbl_name='pinyin'", Result)
	If (Result.Rows[1,1]!="")&&!InStr(Result.Rows[1,1],"jp"){
		MsgBox, 308, 词库调整, 本次更新将调整pinyin词库结构，优化文件占用空间，如有重要信息，请注意备份词库！`n是否继续？
		IfMsgBox, No
			ExitApp
		Progress, B2 ZH-1 ZW-1 FS12, 调整词库中，请稍后...
		DB.Exec("BEGIN TRANSACTION;")
		DB.Exec("DROP TABLE IF EXISTS hebing;")
		DB.Exec("CREATE TABLE hebing (""jp"" TEXT,""Key"" TEXT,""Value"" TEXT,""weight"" INTEGER DEFAULT 0);")
		DB.Exec("INSERT INTO hebing SELECT szm(Key),Key,Value,sum(weight) FROM pinyin GROUP by Key,Value ORDER by 1,Key,weight DESC;")
		DB.Exec("DROP TABLE pinyin;ALTER TABLE hebing RENAME TO pinyin;")
		DB.Exec("CREATE INDEX ""sy_pinyin"" ON ""pinyin"" (""jp"");")
		DB.Exec("DROP TABLE IF EXISTS jianpin;")
		DB.Exec("COMMIT TRANSACTION;")
		DB.Exec("VACUUM")
		Progress, Off
		MsgBox 调整完成
	}
	DB.GetTable("SELECT name FROM sqlite_master WHERE type='table' AND name!='sqlite_sequence' AND instr(sql,'INTEGER PRIMARY Key AUTOINCREMENT')", Result)
	If (Result.RowCount){
		Loop % Result.RowCount
			remaketable(DB,Result.Rows[A_Index,1])
		DB.Exec("VACUUM")
	}
Return

Loadfuzhuma:
ReLoadfuzhuma:
	; srf_fzm_table:={}, 
	srf_fzm_fancha_table:={}
	If !FileExist("Lib\@fzm.txt"){
		fuzhuma:=0
		GuiControl, 3:, fuzhuma, 0
		If (A_ThisLabel="ReLoadfuzhuma")
			MsgBox, 48, 提示, 辅助码文件不存在，请在Lib目录下放置辅助码文件@fzm.txt，格式如下：`n吖=k`n阿=e`n啊=k`n文本编码为UTF-8-Bom或ANSI
	} Else {
		FileRead, tvar, Lib\@fzm.txt
		Loop, Parse, tvar, `n, `r
		{
			If (A_LoopField="")
				Continue
			srf_fzm_fancha_table[(tarr:=StrSplit(A_LoopField, "="))[1]]:=tarr[2]
			; srf_fzm_table[tarr[2]] .= "|" tarr[1]
		}
		; For Key, tvar in srf_fzm_table
		; 	srf_fzm_table[Key]:="(" Trim(tvar, "|") ")"
		Key:=tvar:=""
	}
Return
Registrationfuncandlabel:	; 注册内置函数
	srf_func_table:={}
	For Key,Value In {magic:"magic", run:"run"}
		srf_func_table[srf_Custom_Func[Key]?srf_Custom_Func[Key]:Value]:=Key
	For Key,Value In srf_Default_Func
		srf_func_table[srf_Custom_Func[Value[1]]?srf_Custom_Func[Value[1]]:Value[1]]:=Func(Key)
Return

;备份
Backup(){
	Loop, Files, %A_ScriptDir%\*.*
		If (A_LoopFileFullPath~=StrReplace("i)" A_ScriptDir "\","\","\\") "[^\\]+\.(exe|ahk|db|ini)")
			FileCopy, %A_LoopFileFullPath%, % StrReplace(A_LoopFileFullPath,A_ScriptDir,A_ScriptDir "\backups"), 1
	FileCopyDir, %A_ScriptDir%\Lib, %A_ScriptDir%\backups\Lib, 1
}
;更新
srfAutoupdatefg:
srfUpdate:
	;获取更新信息
	If (!DllCall("Wininet.dll\InternetCheckConnection", "Str", Sourceurl, "UInt", 0x1, "UInt", 0x0, "Int")){
		If (A_ThisLabel="srfUpdate")
			MsgBox, 16, 检查更新, 网络异常,将无法更新脚本！, 5
	} Else {
		If !RegExMatch(var:=Requests(Sourceurl "/yz.ini"), "i)Version=([\d\.]+)", UpdateVersion){
			If (A_ThisLabel="srfUpdate")
				MsgBox, 16, 检查更新, 获取版本信息失败！, 5
		} Else If (Version=UpdateVersion1){
			If (A_ThisLabel="srfUpdate")
				MsgBox, 64, 检查更新, 影子输入法已经是最新版本了。, 5
		} Else If (Version<UpdateVersion1){
			MsgBox, 36, 检查更新, % "检测到影子输入法有新版本`n`n" Version "`t版本更新后=>`t" UpdateVersion1 "`n`n更新说明：`n" RegExReplace(Requests("https://gitee.com/orz707/shadow/raw/master/change.txt"), "im).*v" RegExReplace(UpdateVersion1,"^(\d+\.\d+.\d+)\.\d+","$1") "([^" Chr(2) "]+).*", "$1") "`n是否更新到最新版本？"
			IfMsgBox Yes
			{
				Backup()
				If FileExist("影子输入法32.exe")
					FileMove, 影子输入法32.exe, temp32.exe
				If FileExist("影子输入法64.exe")
					FileMove, 影子输入法64.exe, temp64.exe
				downloadfilenum:=0
				If !URLDownloadToFile(Sourceurl "/影子输入法32.exe", "影子输入法32.exe"){
					If FileExist("temp32.exe")
						FileMove, temp32.exe, 影子输入法32.exe
					MsgBox, 48, 检查更新, 下载影子输入法32位失败, 2
				} Else
					downloadfilenum++
				If !URLDownloadToFile(Sourceurl "/影子输入法64.exe", "影子输入法64.exe"){
					If FileExist("temp64.exe")
						FileMove, temp64.exe, 影子输入法64.exe
					MsgBox, 48, 检查更新, 下载影子输入法64位失败, 2
				} Else
					downloadfilenum++
				RegExMatch(var,"iO)UpdateFile=(.+)", UpdateFile), UpdateFile:=UpdateFile.Value[1]
				Loop, Parse, UpdateFile, `,
				{
					If (A_LoopField~="i)\.exe$"){
						tvar:=RegExReplace(A_LoopField,".*/")
						Process, Exist, %tvar%
						If (ErrorLevel)
							Process, Close, %ErrorLevel%
					}
					If (A_LoopField~="(IMEConverter.exe|yz.icl)"){
						If !URLDownloadToFile("https://autohotkey.oss-cn-qingdao.aliyuncs.com/AutoAHKScript/Scripts/yz/" A_LoopField, StrReplace(A_LoopField,"/","\"))
							MsgBox, 48, 检查更新, % "下载" RegExReplace(A_LoopField,".*/") "失败", 2
					} Else If !URLDownloadToFile(Sourceurl "/" A_LoopField, StrReplace(A_LoopField,"/","\"))
						MsgBox, 48, 检查更新, % "下载" RegExReplace(A_LoopField, ".*/") "失败", 2
				}
				If (downloadfilenum>0){
					Version:=YzIni.Version["Version"]:=UpdateVersion1, YzIni.Save()
					Reload
				}
			}
		}
	}
Return
; 界面
;------------------------------------------------------------------------------------------------------------------------
; 选词框gui、ToolTip
houxuankuangguicreate:
	Height:=60, ToolTip(), GdipText("")
	; Gui, houxuankuang:Destroy
	If (ToolTipStyle=1)
		Tip1hWnd:=ToolTip(1, "", "Q1 B" BackgroundColor " T" TextColor " S" FontSize, FontType)
		; , ToolTip(2, "", "Q1 B" BackgroundColor " T" TextColor " S" FontSize " F" FontType)
Return

;托盘按钮
TRAYMENU:
	Menu, Tray, NoStandard                                         ;去掉标准托盘按钮
	Menu, Tray, DeleteAll                                              ;清空托盘按钮
	Menu, Tray, Add, 词库管理, cikuManager
	Menu, Tray, Icon, 词库管理, Lib\yz.icl, 3
	Menu, Tray, Add
	Menu, Tray, Add, 选项, Option
	Menu, Tray, Icon, 选项, Lib\yz.icl, 4
	Menu, Tray, Add, 更新, srfUpdate
	Menu, Tray, Icon, 更新, Lib\yz.icl, 5
	Menu, Tray, Add, 帮助, Help
	Menu, Tray, Icon, 帮助, Lib\yz.icl, 6
	Menu, Tray, Add, 关于, ABOUT
	Menu, Tray, Icon, 关于, Lib\yz.icl, 7
	Menu, Tray, Add
	Menu, Tray, Add, 禁用, srfsuspend
	Menu, Tray, Icon, 禁用, Lib\yz.icl, 14
	Menu, Tray, Add, 重启, srfreload
	Menu, Tray, Icon, 重启, Lib\yz.icl, 8
	Menu, Tray, Add, 退出, EXIT
	Menu, Tray, Icon, 退出, Lib\yz.icl, 9
	Menu, Tray, Default, 词库管理
	Menu, Tray, Tip, 影子
	Menu, Tray, Icon, Lib\yz.icl, 1, 1
	Menu, Tray, Click, 2
Return

;加载logo
LoadLogo:
SetLogoSize:
	WinGetPos,,,,TrayWnd_Height,ahk_class Shell_TrayWnd
	Gui, 2:Destroy
	If (A_OSVersion="WIN_XP"){
		Gui, 2:-Caption +AlwaysOnTop +ToolWindow -DPIScale +HwndHGui2
		If FileExist("yz.png")
			Gui, 2:Add, Picture, , yz.png
		Else
			Gui, 2:Add, Picture, Icon1, Lib\yz.icl
		Gui, 2:Show, % "NA x" A_ScreenWidth-A_ScreenWidth//5-(64*LogoSize//200) " y" A_ScreenHeight-TrayWnd_Height-(64*LogoSize//100)
		WinSet, TransColor, F0F0F0 255, ahk_id%HGui2%
	} Else {
		If (!pToken:=Gdip_Startup()){
			MsgBox, 48, gdiplus error!, Gdiplus failed to start. Please ensure you have gdiplus on your system
			ExitApp
		}
		If FileExist("yz.png")
			pBitmap:=Gdip_CreateBitmapFromFile("yz.png")
		Else
			pBitmap:=Gdip_BitmapFromBase64(""
			. "iVBORw0KGgoAAAANSUhEUgAAAC8AAAA+CAYAAAC7rUKSAAANFklEQVRogX1aacitVRV+1v6OwY3UFGkk"
			. "LArjqpGaP+RKiESFaDdQsCQhMyLKikKrX/6JaKABo4GKbFAsIygrM9NyzqFUMEiLqxGaXJMGpTSzzn5i"
			. "772m/Z7v6/34eM95p7PW2s961vTK3jechlIKtspW3/f/rbbX7yKQIihSIFtb43v+L2XsQQDtMwCRg0G+"
			. "BJDDpeBQALv6aeBfJP8O4EGI7Ce5n5UAK/qu/dUKkqjrNSraqTXquqLWinU71q5dV6zrGqsmVBfMBOrC"
			. "lFlA/W6K9L98vsmLciJEXgPBiQCOE5HDkLd2EdHv51DkSRC/F8FtJG4Uwc0g9tNuaVboFwp22lbtXAgu"
			. "/R5ZWLdMFrbjXZBdArwfkLcAOGoIyPHDKmzfbN/kqS7QMwEcS+BYiLyb5NMAbgRwJYBLADw237y5FRnS"
			. "JsGWVtfz+uMDF/3L+wDZB+BjXXBwEpb6lZz/x9agUV0wPf4MAq8F8DkQfwD5aZBH2h3cRocy41f+j+Cq"
			. "HHCqiNwrkPYjL3SL9mWuIX2t43tV6VUjV0hFbytBv17Pg4dQcD6I35L4Nsnj7bnNH6gPGAhWizoc9H8W"
			. "HM/VJb2SwG6a1VSAEGw8vKlRu+zs/+2aque6wAznpN5b+3E91nWp7ZqzSPya4FUkT2YoOOjBcKy4SP8O"
			. "1SMA3Ang1AxDJst2BVSoOgk2IFK57scaa1Rllfa5X7dOn5uSVc/3e2HPOIXAdSAuJeuL2rNXybIbmx47"
			. "od8E2WXrLQYTtbTf7Ji3VakBfIS/DJg44sffWvcKoy64KaLH6/g/G8QZID60ys44YX3IcoKI3BZeKKAo"
			. "YNeJVWo4K81xRRUzpURxZDqOx+lqVdWxDrgotvtqNEXW+llXsta6q9b6+VU4U1BDu0Bk61gQt3QhzJqm"
			. "Zb5HjLeNOXRfFxQhYXF/BKisoz9tvoAZft1vJn/o59crWeCl3SiURn13Ndu0Z/drenAxV0nbOrmuO5Ou"
			. "xsbVdBoNzqeicXyu5kNm+W7pdmjtKzB8oT68ojuorW6HwiXN+GgQKWp0x3to61bWVRscA3eygQtGoGRS"
			. "hpyUcMMYhOpwVlfAGavaaty8QtdiWFXGMp1LlOO64I6GxirFLRvK6g/WbT4zbE6LVBKKzsrHnqqUQ8SF"
			. "XutqKJOBN3XLe8AADwTkYuYjdTjwsGSY0MFiQWbi+ZqibA5Q4pCwVIK+OotnIMeDsapDcMf+das5fst3"
			. "LMCUMlZENlhjqFvN4eqgxPFQ/cyEZ4dItrIyVyLLzjobq2A8vwhq4P2svH/lEZE8BbWe2hKwEa3VA8To"
			. "Bk6L8w9gA6dDAXPOpeABq/bAbHH3jxR155X0FbmiBynTCCKf6hZvAliaKwNSHoTqLABrxmmdlzrlIOEb"
			. "m35AJ/wdFOC8euNzvb5ds+rOUHB8Wa+PQimonow1q880l/HJLACVBXLeokseQrjKiZ0CjmGUTKk1/MT9"
			. "ApY6Y9V+tLC8vXYfqoMqS0oXHDY1IiNmSGTrRzBJkHGrbQOlSdh0bJkDi9J4QYv4T3ThWesBFTizp8PV"
			. "hNbkN+K8rewEhaUjTVmjprl1WvK0Cp7vBC7NYGVKbTH4MPKvK+zWVa11jwCHdsHLyFVkvVkJzUtcA/NI"
			. "9GUJFK0uHVavJqxaz4QTzY1cLJGlPmFELwvx/RCePEGqwsXTl0jW5rwF4XiL/F0Dh58zwduzSjen1sFF"
			. "HIpTsRPS9t/QSL+oYbmPxIMWIpvljzZmGWZg1tet3Y4vaQxJyGpOqjlNz063StS8VrgXUQq2VESS0dPn"
			. "TM9huKsjoZMm/PrF9hC/acpFMtsk6ktwcAe0tLoUL+RbZwK5tIQpsqjUllbOnQPxOPEzumM3y6/rC3Ky"
			. "tVFYYJPGJqczHJdUvKf2SCeIFvgS1jt0usxlxvwGSkIOgn8R8BojWKrDPnvHG6H5yLwEbikxqwIb/ZzB"
			. "uON8Frp7gMT1A6nJcbPxveLqPnAryf+MVJOdulcEDwjBZKGDRdribQ+vuuz8kjVUKS/mW5lcQtlJSTNE"
			. "mdnGRO9KFU03gIdgzYnSFBCsSilcLBxmGM1OtDyXsTs5Yy7sc8sQIaxb36J5frauxoDsFqTyborFjXGu"
			. "Cf+UQA6a+XaJwyX/LlghMYc53iw85paiX5uu9x+W6LpZcGrkILjKr5PSV2NVytZfBfKcnupKSV5vZccm"
			. "30r+wJnbHEZMFjZYWcHu/U1stl06s5RFdJebpOCRbvHmA4U9G2iWf0Qguwes7QGYLZIsvLFlf5lWJfzA"
			. "rZ0Sj8D+cqWLyk6vJ0D+NDxh6NfZppTyx+DeoXl30GVoBnw5mdlHFk9NBzS2zpssHTOtwcQ0pfuBxtpr"
			. "6bl5BKFVKXKfbOAx0oQNa1uNKrkWtdZGWgSWQEGWcbuNC2f1ZLbD5m8A7rJV7TWGPnQlIjdNLWxzIkuF"
			. "JZvWYKhpbtFrLI8J6W6AtE5vJ/VDIGi9+t1gHzSEI07W30Ep4uooiKv/djvUHPYOEXmkiDyvl4DOzwnD"
			. "2coy2iC924C8Cp7FtZ7myZ78h+4HQrgXxJkQ2avxB8Xldoio3COOisiPBvZHxdWhpIxUSo985bJueRvr"
			. "tGlJ4+UtHfGIjXqUq/W67driAJ6/Azj+AeAyAG8k8TICFwXUcnVlNhDN5HmDtUEqUlHTl7V0AS6SPt4Z"
			. "hUAXrM2kZMykypYKbUoZzDyfCQcX9J79BR3sSzS4n/MBkB9owwOSDw5ZvT7Vqq0L+hsQfx79CnuY+HOG"
			. "5SF/KkUuzolVsVmU+0K2to145pQ3pQYfh8irPBp7ghV5ksL2PpDHgLzB+6SpbgBwS7RKckFuw4Woas4T"
			. "kX39x1E8D+mWTgq4gsbVVrEhmArSWudyO4Czs9mtU5AbUUCbDrahAc4n8ZhnkVVT4NzLXNTPhfBf/7eI"
			. "nCRF/psHa87BdqxEW2Tea2C0+NDaKsClEHzE7dijZer5pPSa4GcJvpzkV6P7wF/Q2nu6t5Z4d9ig3y7t"
			. "foAnRYEgPnf1utOGbiWctUvtM6uN/OhCAN8MBdIHN7477KMk30lyD4DzCDwxNV/cwW3qG25gVrsVkHPn"
			. "gK7nxCJwumuqgiR2Ge/AWwF8NwMo4gOCRbwDx9tIfmlqm2zzP8XvmFLiGxCcBchToZknr3oosO+Id6Mv"
			. "aGZ8PRPg5YHduTKLxlJNkKo7Co5seSz7PMTlAI+A4AsR56OfYvVJVFVpdSaDTHnMm/p4EjzSpiueEmEh"
			. "YN1sbGFxXWGG4eb2EID3Ygx399nqRPY5F84RqGbATfka0AbDdxI4YtkC9Dxo2dTC0uoOmyx+Lm+n7ecA"
			. "jh6r4E93TIyswlkrmMr2RZbP2wXgdrRhMYPXvSG74PS5eYsEmyR7igfR2Izt6bEKbV6Fy7d13FRcxApF"
			. "DFh0KZrg10/TDx9d1g3rY9OpUXZ0CE5rmH3hXoicJVJOBOUnJlB+4UIDQrT0Uso1sZDglRbIormiWFdu"
			. "n4bUaRDC3iBG/LnpEdp5qE7tM/39WwGcBuIYCL4HRiq9UXzLqI6iVpho9FKMVwOcv6mcjg0wx77DNS8b"
			. "fd65/A/Bp20Y+B5BOVMErwfKPfNrLYKSOgmTAjLB6BPGLD7AqGkua0OMih1gM7WscwI0ta2i7nCNnNyv"
			. "EcExAnw0UGPl3TxZX0CnbecAPNjc1saiTK+2THsVongHqmYHTdjbJjjMpXSizyHghSLyntFswiSwJXOu"
			. "wNxi2Rvcn6JYngksZgMlXlSwLm+dR+VL2kL+XN18U/1b5ItS8C6RUj3ft6w0N51ywS14NVOaMRP4/G8r"
			. "VpY8Or8TMyuACS5ps/ShILPKlwX41pTAZWf21fOlPDxT2kb8yWSihNIHaq2J04vbNuUuOltqRVbVvmCA"
			. "+5MADoPgalB+CeDhOY2JNjnBg6TI7g7JhHFjiq6pvxnV73zKzm4nv5fR/p19MtIfIip4f1OiNrzW8aph"
			. "m5q0YmSw10sFOB2Ut4m0ebrcAeCHfTonPX1oL73tliKvA3EOicM6RMaLDK1lp+lzxfgyChMZBcoDOdPc"
			. "zt+mAV0fqLnFqxqijTNrL/Bq762LvmbSl/9XlHK6QmdLgD2A7BncX/7Zwj5bV9QB4a+MDCGLCReJno1H"
			. "AfzYlFkmKPm77wdVQnGO2Rn1u7+sOYbfN0eES84zKqdnDYVSy9smJJ60RSqNTKOQ1i65PnnBLLQXLLO/"
			. "FacnVndSpBcW4g29zq+twf/49JA8aE7Hl7we+Q2cZr25JThjJ0fdyHkT83W2qfrSg71RVBmvRdnbeTXe"
			. "zvvwcJOIfvFwLyijQ40SXYOcPthn4B3t9VxvLy63jegeMajE20aZFk3wOkVbPf8VkhcAfDxbekKqFyap"
			. "OnSeNxbHowJ8EMDXNiVeyDv9RmxtrBO4tdzOgKa98D7iNxrtl9XPkPJ1SHkz0Fp48orebDJh80LY/BfS"
			. "5km/g8jdgFwLwQ+EfHL+5e3kT+8rJDICiP8BCkrJxs8fqYQAAAAASUVORK5CYII=")
		PW:=Gdip_GetImageWidth(pBitmap), PH:=Gdip_GetImageHeight(pBitmap)
		Gui, 2:-Caption +E0x80000 +LastFound +AlwaysOnTop +ToolWindow -DPIScale +HwndHGui2
		Gui, 2:Show, NA
		hbm:=CreateDIBSection(PW*LogoSize//100, PH*LogoSize//100), hdc:=CreateCompatibleDC()
		obm:=SelectObject(hdc, hbm), G:=Gdip_GraphicsFromHDC(hdc), Gdip_SetInterpolationMode(G, 7)
		Gdip_DrawImage(G, pBitmap, 0, 0, PW*LogoSize//100, PH*LogoSize//100, 0, 0, PW, PH)
		UpdateLayeredWindow(HGui2, hdc, A_ScreenWidth-A_ScreenWidth//5-(PW*LogoSize//200), A_ScreenHeight-TrayWnd_Height-(PH*LogoSize//100), PW*LogoSize//100, PH*LogoSize//100)
		SelectObject(hdc, obm), DeleteObject(hbm), DeleteDC(hdc), Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap)
		Gdip_Shutdown(pToken), pToken:=0
	}
	If (A_ThisLabel="SetLogoSize"){
		If !(srf_mode)
			Gui, 2:Hide
		Return
	}
	Gui, 2:Hide

	;检验加载
	DB:=new SQLiteDB
	If !DB.OpenDB(main){
		MsgBox, 16, 数据库错误, % "消息:`t" DB.ErrorMsg "`n代码:`t" DB.ErrorCode
		ExitApp
	}
	DB.CreateScalarFunc("REGEXP", 2, RegisterCallback("SQLiteDB_RegExp", "C"))
	DB.CreateScalarFunc("szm", 1, RegisterCallback("shouzimu", "C"))
	DB.CreateScalarFunc("erjiayi", 2, RegisterCallback("erjiayi", "C"))
	DB.Exec("DROP TABLE IF EXISTS ''")
	DB.AttachDB(extend, "extend")
	If (extend!=main)&&DB.GetTable("SELECT name FROM sqlite_master WHERE type='table' AND tbl_name IN ('functions','hotstrings','customs','symbol')",TableInfo){
		Loop % TableInfo.RowCount
			DeriveFromDB(DB, TableInfo.Rows[A_Index, 1], "SELECT ROWID,Key,Value,comment FROM 'main'.'" TableInfo.Rows[A_Index, 1] "' ", "main_" A_Now), DB.Exec("DROP TABLE 'main'.'" TableInfo.Rows[A_Index, 1] "'")
		If (TableInfo.RowCount)
			MsgBox, 64, 导出词库, main词库中的超级命令、魔法字符串、自定义短语、特殊符号已导出，存放在%A_ScriptDir%目录
	}
Return

96GuiEscape:
	99GuiEscape:
	Gui Hide
Return

Help:
	Gui, 96:Destroy
	Gui, 96:Margin, 20, 20
	Gui, 96:Add, Picture, xm w13 h-1 Icon1, Lib\yz.icl
	Gui, 96:Font, s11 Bold, %FontType%
	Gui, 96:Add, Text, x+10 yp, 简易帮助
	Gui, 96:Font
	Gui, 96:Font, s11, %FontType%
	Gui, 96:Add, Text, y+5, - LShift切换输入模式
	Gui, 96:Add, Text, y+5, - Space首选上屏, Enter英文字符上屏
	Gui, 96:Add, Text, y+5, - /键 内置功能键
	Gui, 96:Add, Text, y+5, - 1、2、3、……、，、。候选上屏
	Gui, 96:Add, Text, y+5, - Ctrl + 1、2、3、……调节对应项到首选，`n  长按调至指定位置
	Gui, 96:Add, Text, y+5, - Ctrl + Alt + 1、2、3、……删除对应词条
	Gui, 96:Add, Text, y+5, - Ctrl + = 快捷造词
	Gui, 96:Add, Text, y+5, - 在选项、词库管理的控件处停留0.5秒`n  显示详细说明
	Gui, 96:Add, Picture, xm y+20 w13 h-1 Icon11, Lib\yz.icl
	Gui, 96:Font, s11 Bold, %FontType%
	Gui, 96:Add, Text, x+10 yp, 详细帮助
	Gui, 96:Font
	Gui, 96:Font, s11, %FontType%
	Gui, 96:Add, Link, y+5, <a href="https://gitee.com/orz707/shadow/wikis">影子帮助文档</a>
	Gui, 96:Show, , % application_name " v " srf_default_value["Version","Version"] " 帮助"
Return

ABOUT:
	Gui, 99:Destroy
	Gui, 99:Margin, 20, 20
	Gui, 99:Add, Picture, xm w13 h-1 Icon1, Lib\yz.icl
	Gui, 99:Font, s11 Bold, %FontType%
	Gui, 99:Add, Text, x+10 yp, 简介
	Gui, 99:Font
	Gui, 99:Font, s11, %FontType%
	Gui, 99:Add, Text, y+10 w300, %A_Space%%A_Space%%A_Space%%A_Space%%Yz_Abort%
	Gui, 99:Add, Picture, xm y+10 w13 h-1 Icon11, Lib\yz.icl
	Gui, 99:Font, s11 Bold, %FontType%
	Gui, 99:Add, Text, x+10 yp, 主页:
	Gui, 99:Font
	Gui, 99:Font, s11, %FontType%
	Gui, 99:Add, Link, x+0 yp, <a href="https://www.autoahk.com/archives/15117">https://autoahk.com/archives/15117</a>
	Gui, 99:Font, s11 Bold, %FontType%
	Gui, 99:Add, Text, xm+25 yp+25, Gitee:
	Gui, 99:Font
	Gui, 99:Font, s11, %FontType%
	Gui, 99:Add, Link, x+0 yp, <a href="https://gitee.com/orz707/shadow">https://gitee.com/orz707/shadow</a>
	; Gui, 99:Font, s11 Bold, %FontType%
	; Gui, 99:Add, Text, xm+25 yp+25, GitHub:
	; Gui, 99:Font
	; Gui, 99:Font, s11, %FontType%
	; Gui, 99:Add, Link, x+0 yp, <a href="https://github.com/wind707/Shadow">https://github.com/wind707/Shadow</a>

	Gui, 99:Add, Picture, xm y+20 w13 h-1 Icon10, Lib\yz.icl
	Gui, 99:Font, s11 Bold, %FontType%
	Gui, 99:Add, Text, x+10 yp, 大本营
	Gui, 99:Font
	Gui, 99:Font, s11, %FontType%
	Gui, 99:Add, Text, y+10, 这里有更多精美的工具和脚本.
	Gui, 99:Add, Link, y+10, <a href="https://www.autoahk.com">【AutoHotkey中文社区】</a>
	Gui, 99:Add, Link, y+10, <a href="https://jq.qq.com/?_wv=1027&k=5zTs1e1">348016704【AutoHotkey中文社区】</a>
	Gui, 99:Add, Link, y+10, <a href="https://jq.qq.com/?_wv=1027&k=5mwdF5c">331028595【影子输入法官方群】</a>

	Gui, 99:Add, Picture, xm y+20 w13 h-1 Icon12, Lib\yz.icl
	Gui, 99:Font, s11 Bold, %FontType%
	Gui, 99:Add, Text, x+10 yp, 感谢
	Gui, 99:Font
	Gui, 99:Font, s11, %FontType%
	Gui, 99:Add, Text, y+10 w300, 非常感谢大家的支持, 感谢Hello_srf、胡杨、jeff、is1or0（大量优秀建议）、心如止水、大唐（云输入）、琪C（图标）、赵小峰（词库）
	Gui, 99:Show, ,  % application_name " v " srf_default_value["Version","Version"] " 关于"
Return